#include "bup.h"

//
// functions
//

int serial_stat(dword *freesize,dword *freeblock,dword *datanum)

{
  int result;
  byte out_buf [4];
  dword *pdStack_28;
  dword *pdStack_24;
  dword *pdStack_20;
  dword out_buf2_ [4];
  
  pdStack_28 = datanum;
  pdStack_24 = freesize;
  pdStack_20 = freeblock;
  result = serial_send_cmd__(0x10,*datanum,out_buf);
  if (((int)(char)out_buf[0] & 0xffU) == (int)(short)SERIAL_ERROR_06028a68) {
    result = Serial_ProcessError_((int)DAT_06028a6a);
    return result;
  }
  if (result != 0) {
    return result;
  }
  result = serial_read_data___(out_buf2_,0x12,PTR_DAT_06028a6c);
  if (result != 0) {
    return result;
  }
  *pdStack_24 = out_buf2_[1];
  *pdStack_20 = out_buf2_[2];
  *pdStack_28 = out_buf2_[3];
  result = Serial_Read_error__(out_buf);
  if (result != 0) {
    return result;
  }
  if (((int)(char)out_buf[0] & 0xffU) == (int)(short)SERIAL_ERROR_0xff_2) {
    return 0;
  }
  return (int)(short)SERIAL_ERROR_0x107;
}


BUP_ERROR BUP_Delete(BACKUP_DEVICE device,uchar *filename)

{
  int iVar1;
  BUP_ERROR BVar2;
  short sVar3;
  backup_stat stat;
  
  if (device != DEVICE_SERIAL) {
                    /* Stat device
                        */
    BVar2 = (*(code *)(DAT_06027bcc + 0x6027b96))(device,0,&stat);
    if (BVar2 != BUP_SUCCESS) {
      return BVar2;
    }
    sVar3 = SearchForSaveBlock((char *)filename,DEFAULT);
    if (sVar3 != 0) {
      DeleteFileByID();
      return BUP_SUCCESS;
    }
    return BUP_NOT_FOUND;
  }
  if ((*PTR_INTERNAL_METADATA_06027b30)->serial_connected == 0) {
    return BUP_NOT_CONNECTED;
  }
  iVar1 = (*(code *)(PTR_PTR_DAT_06027b34 + 0x6027b24))(filename);
  if (iVar1 == 0) {
    return BUP_SUCCESS;
  }
  if (iVar1 == 0x21) {
    return BUP_NOT_CONNECTED;
  }
  if (iVar1 == 0x23) {
    return BUP_WRITE_PROTECTED;
  }
  if (iVar1 == 0x24) {
    return BUP_NOT_FORMATTED;
  }
  if (iVar1 != 0x30) {
    if ((iVar1 != DAT_06027bc8) && (iVar1 != DAT_06027bca)) {
      return ~BUP_SUCCESS;
    }
    return BUP_NOT_CONNECTED;
  }
  return BUP_NOT_FOUND;
}


BUP_ERROR ChecksumData(short block_id,byte *input_data)

{
  byte *pbVar1;
  byte *backup_ram_start;
  uint j;
  int iVar2;
  INTERNAL_METADATA *im2;
  undefined4 *save_size_ptr;
  short *saved_sat_blocks;
  int block_type_flag;
  uint bytes_read;
  int curBlock;
  int i;
  int block_offset;
  undefined4 save_size;
  byte abStack_24 [4];
  byte *pbStack_20;
  INTERNAL_METADATA **im;
  
  im = PTR_INTERNAL_METADATA_060280c8;
  block_type_flag = 0;
  curBlock = 1;
  bytes_read = 0;
  *(undefined4 *)&(*PTR_INTERNAL_METADATA_060280c8)->bad_block = 0;
  *(*im)->sat_blocks = block_id;
  i = 0;
  do {
    if ((*im)->sat_blocks[i] == 0) {
      return BUP_SUCCESS;
    }
    j = 0;
    if ((*im)->totalBlocks < ((int)(*im)->sat_blocks[i] & 0xffffU)) {
      return BUP_BROKEN;
    }
    im2 = *im;
    block_offset = ((int)im2->sat_blocks[i] & 0xffffU) * im2->blockSize_in_bytes;
    backup_ram_start = im2->backup_ram_start;
    if (block_type_flag == 0) {
      block_type_flag = 1;
      j = 0x3c;
      pbStack_20 = abStack_24;
                    /* Read the save sizve from the SAT header
                        */
      save_size_ptr = &save_size;
      do {
        *(byte *)save_size_ptr = backup_ram_start[j + 1 + block_offset];
        *(byte *)((int)save_size_ptr + 1) = backup_ram_start[j + 3 + block_offset];
        save_size_ptr = (undefined4 *)((int)save_size_ptr + 2);
        j = j + 4;
      } while (save_size_ptr < pbStack_20);
SAT_CONT_BLOCK:
      if (j == 0) {
        j = 8;
      }
                    /* Parse the SAT block list */
      for (; (j < (*im)->blockSize_in_bytes && ((*im)->sat_blocks[curBlock + -1] != 0));
          curBlock = curBlock + 1) {
        saved_sat_blocks = (*im)->sat_blocks;
        *(byte *)(saved_sat_blocks + curBlock) = backup_ram_start[j + 1 + block_offset];
        iVar2 = j + 3;
        j = j + 4;
        *(byte *)((int)(saved_sat_blocks + curBlock) + 1) = backup_ram_start[iVar2 + block_offset];
      }
      if ((*im)->sat_blocks[curBlock + -1] == 0) {
        block_type_flag = 2;
SAT_END_BLOCK:
        if (j == 0) {
          j = 8;
        }
        while ((j < (*im)->blockSize_in_bytes && (bytes_read < save_size))) {
          iVar2 = j + 1;
          pbVar1 = input_data + bytes_read;
          j = j + 2;
          bytes_read = bytes_read + 1;
          if (*pbVar1 != backup_ram_start[iVar2 + block_offset]) {
                    /* found a bad block */
            *(uint *)&(*im)->bad_block = (int)(*im)->sat_blocks[i] & 0xffff;
            return BUP_NO_MATCH;
          }
        }
      }
    }
    else {
      if (block_type_flag == 1) goto SAT_CONT_BLOCK;
      if (block_type_flag == 2) goto SAT_END_BLOCK;
    }
    i = i + 1;
  } while( true );
}


undefined4 find_free_blocks__(uint blocks_needed_)

{
  ushort uVar1;
  uint read_offset2;
  int power_of_two_index;
  short *sat_blocks;
  byte *backup_ram_save_area_start2;
  byte *extraout_r3;
  INTERNAL_METADATA *im3;
  dword read_offset2_high;
  uint j;
  ushort *puVar2;
  byte *tag_ptr;
  ushort *puVar3;
  uint total_blocks_divided_8;
  int offset;
  undefined2 block_index;
  uint block_index2;
  byte *backup_ram_save_area_start;
  undefined2 *block_index_low;
  uint tag;
  byte *block_index_high;
  int found_busy_blocks_index;
  int current_block_index;
  byte powers_of_two [8];
  INTERNAL_METADATA **im2;
  uint k;
  char read_offset;
  bool some_flag;
  
  im2 = PTR_INTERNAL_METADATA_060274a0;
  block_index_low = &block_index;
  setupPowersOf2Struct(powers_of_two);
  for (k = 0; k < (*im2)->totalBlocks >> 3; k = k + 1) {
    *(undefined *)((int)(*im2)->sat_blocks + k) =
         *(undefined *)(k * 2 + (*im2)->backup_ram_bad_blocks_bitmap + 1);
  }
  im3 = *im2;
  backup_ram_save_area_start = im3->backup_ram_start + im3->blockSize_in_bytes * 2;
  total_blocks_divided_8 = im3->totalBlocks >> 3;
  sat_blocks = im3->sat_blocks;
  tag_ptr = (byte *)&tag;
  block_index_high = (byte *)((int)&block_index + 1);
                    /* Walk all of the blocks after the header. Find blocks that are busy (0x800000)
                       tag and not on the bad block bitmap. */
  for (k = (*im2)->offset_of_filedata_in_blocks; k < (*im2)->totalBlocks; k = k + 1) {
    if (((char)backup_ram_save_area_start[1] < 0) &&
       ((*(byte *)((k >> 3) * 2 + (*PTR_INTERNAL_METADATA_06027540)->backup_ram_bad_blocks_bitmap +
                  1) & powers_of_two[k & 7]) == 0)) {
      backup_ram_save_area_start2 = (byte *)((k >> 3) + (int)(*im2)->sat_blocks);
      *backup_ram_save_area_start2 = *backup_ram_save_area_start2 | powers_of_two[k & 7];
      read_offset = 34;
      some_flag = true;
      found_busy_blocks_index = 0;
      current_block_index = 0;
      backup_ram_save_area_start2 = backup_ram_save_area_start;
                    /* Walk the sat block list of this busy save */
      while (some_flag) {
        read_offset2 = (uint)read_offset;
        while (read_offset2 < (*im2)->blockSize) {
          read_offset2_high = read_offset2 + 1;
          *(byte *)block_index_low = backup_ram_save_area_start2[read_offset2 * 2 + 1];
          *block_index_high = backup_ram_save_area_start2[read_offset2_high * 2 + 1];
          if (block_index == 0) {
                    /* found 0x0000 terminator block index */
            some_flag = false;
            read_offset2_high = (*im2)->blockSize;
          }
          else if (((int)block_index & 0xffffU) < (*im2)->totalBlocks) {
                    /* Unclear?? save block index to sat_blocks? */
            block_index2 = (int)block_index & 0xffff;
            power_of_two_index = (*(code *)(PTR_LAB_060275f8 + 0x602756c))();
            *extraout_r3 = *extraout_r3 | powers_of_two[power_of_two_index];
            *(byte **)((int)sat_blocks + found_busy_blocks_index * 4 + total_blocks_divided_8) =
                 (*im2)->backup_ram_start +
                 (*im2)->blockSize_in_bytes * ((int)block_index & 0xffffU);
            found_busy_blocks_index = found_busy_blocks_index + 1;
          }
          read_offset2 = read_offset2_high + 1;
        }
        read_offset = 4;
        backup_ram_save_area_start2 =
             *(byte **)((int)sat_blocks + current_block_index * 4 + total_blocks_divided_8);
        current_block_index = current_block_index + 1;
      }
    }
    backup_ram_save_area_start = backup_ram_save_area_start + (*im2)->blockSize_in_bytes;
  }
  k = 0;
  while (k < blocks_needed_) {
    read_offset2 = 0xffffffff;
    for (j = (*im2)->offset_of_filedata_in_blocks; j < (*im2)->totalBlocks; j = j + 1) {
      if ((*(byte *)((j >> 3) + (int)(*im2)->sat_blocks) & powers_of_two[j & 7]) == 0) {
        backup_ram_save_area_start2 = (*im2)->backup_ram_start;
        offset = (*im2)->blockSize_in_bytes * j;
                    /* read the first 4 bytes of the tag? */
        *tag_ptr = backup_ram_save_area_start2[offset + 1];
        *(byte *)((int)tag_ptr + 1) = backup_ram_save_area_start2[offset + 3];
        *(byte *)((int)tag_ptr + 2) = backup_ram_save_area_start2[offset + 5];
        *(byte *)((int)tag_ptr + 3) = backup_ram_save_area_start2[offset + 7];
        if (tag < read_offset2) {
          read_offset2 = tag;
        }
      }
    }
    for (read_offset2_high = (*im2)->offset_of_filedata_in_blocks;
        read_offset2_high < (*im2)->totalBlocks; read_offset2_high = read_offset2_high + 1) {
      j = k;
      if ((*(byte *)((read_offset2_high >> 3) + (int)(*im2)->sat_blocks) &
          powers_of_two[read_offset2_high & 7]) == 0) {
        backup_ram_save_area_start2 = (*im2)->backup_ram_start;
        power_of_two_index = (*im2)->blockSize_in_bytes * read_offset2_high;
        *tag_ptr = backup_ram_save_area_start2[power_of_two_index + 1];
        *(byte *)((int)tag_ptr + 1) = backup_ram_save_area_start2[power_of_two_index + 3];
        *(byte *)((int)tag_ptr + 2) = backup_ram_save_area_start2[power_of_two_index + 5];
        *(byte *)((int)tag_ptr + 3) = backup_ram_save_area_start2[power_of_two_index + 7];
        if (read_offset2 == tag) {
          j = k + 1;
          *(short *)((int)sat_blocks + k * 2 + total_blocks_divided_8) = (short)read_offset2_high;
          if (j < blocks_needed_) {
            backup_ram_save_area_start2 =
                 (byte *)((read_offset2_high >> 3) + (int)(*im2)->sat_blocks);
            *backup_ram_save_area_start2 =
                 *backup_ram_save_area_start2 | powers_of_two[read_offset2_high & 7];
          }
          else {
            read_offset2_high = (*im2)->totalBlocks;
          }
        }
      }
      k = j;
    }
  }
  for (k = 0; k < blocks_needed_ - 1; k = k + 1) {
    puVar3 = (ushort *)((int)sat_blocks + k * 2 + total_blocks_divided_8);
    read_offset2 = k;
    while (read_offset2 = read_offset2 + 1, read_offset2 < blocks_needed_) {
      if (*(ushort *)((int)sat_blocks + read_offset2 * 2 + total_blocks_divided_8) < *puVar3) {
        uVar1 = *puVar3;
        puVar2 = (ushort *)((int)sat_blocks + read_offset2 * 2 + total_blocks_divided_8);
        *puVar3 = *puVar2;
        *puVar2 = uVar1;
      }
    }
  }
                    /* Copy found free blocks to sat_blocks list?? */
  k = 0;
  if (blocks_needed_ != 0) {
    do {
      read_offset2 = k + 1;
      (*im2)->sat_blocks[k] = *(short *)((int)sat_blocks + k * 2 + total_blocks_divided_8);
      k = read_offset2;
    } while (read_offset2 < blocks_needed_);
  }
  (*im2)->sat_blocks[blocks_needed_] = 0;
  return 0;
}


/* WARNING: Unknown calling convention -- yet parameter storage is locked */

int checkFormatted(void)

{
  uint j;
  uint i;
  byte *backup_ram;
  byte backupFormatStr [24];
  INTERNAL_METADATA **puVar1;
  
  puVar1 = PTR_INTERNAL_METADATA_06026e94;
  InitBackupRamFormatString((char *)backupFormatStr);
  backup_ram = (*puVar1)->backup_ram_start;
  i = 0;
  do {
    if ((*puVar1)->blockSize - 0xf <= i) {
      return 1;
    }
    if (backup_ram[i * 2 + 1] == backupFormatStr[0]) {
      j = 0;
      do {
        if (backup_ram[(i + j) * 2 + 1] == backupFormatStr[j]) {
          if (j == 0xf) {
            return 0;
          }
        }
        else {
          j = 0x10;
        }
        j = j + 1;
      } while (j < 0x10);
    }
    i = i + 1;
  } while( true );
}


void convert_days_to_month_date(uint days,uchar *month,uchar *day,uchar leap_year)

{
  uint i;
  uint months [12];
  char days2;
  
  setup_days_by_month(months);
  i = 1;
  days2 = (char)days;
  if (days < months[0]) {
    *month = 1;
    *day = days2 + 1;
  }
  else if (leap_year == 0) {
    for (; (months[i] <= days && (i < 0xb)); i = i + 1) {
    }
    *month = (char)i + 1;
    *day = (days2 - (char)months[i - 1]) + 1;
  }
  else {
    for (; (months[i] < days && (i < 0xb)); i = i + 1) {
    }
    *month = (char)i + 1;
    *day = days2 - (char)months[i - 1];
    if (*month == 2) {
      *day = *day + 1;
    }
  }
  return;
}


longlong crazyDiv2(int divisor,int dividend)

{
  bool bVar1;
  bool bVar2;
  bool bVar3;
  uint uVar4;
  char cVar5;
  bool bVar6;
  bool bVar7;
  uint uVar8;
  uint uVar9;
  undefined *puVar10;
  uint uVar11;
  uint uVar12;
  uint uVar13;
  uint uVar15;
  uint uVar16;
  uint uVar17;
  uint uVar18;
  uint uVar19;
  uint uVar20;
  uint uVar21;
  uint uVar22;
  uint uVar23;
  uint uVar24;
  uint uVar25;
  uint uVar26;
  uint uVar27;
  uint uVar28;
  uint uVar29;
  uint uVar30;
  uint uVar31;
  uint uVar32;
  uint uVar33;
  uint uVar34;
  uint uVar35;
  uint uVar36;
  uint uVar37;
  uint uVar38;
  uint uVar39;
  uint uVar40;
  uint uVar41;
  uint uVar42;
  uint uVar43;
  uint uVar44;
  uint uVar14;
  
  puVar10 = PTR_DAT_06029b98;
  if (divisor != 0) {
    bVar1 = (dividend & 0x80000000U) != 0;
    uVar8 = -(uint)bVar1;
    uVar11 = dividend - (uint)(uVar8 != 0);
    bVar2 = (uVar8 & 0x80000000) != 0;
    bVar3 = (divisor & 0x80000000U) != 0;
    uVar4 = (uint)bVar3 << 9;
    uVar9 = uVar11 * 2;
    uVar11 = (uint)bVar1 * -2 | (uint)((uVar11 & 0x80000000) != 0);
    bVar6 = bVar2 == bVar3;
    bVar7 = bVar3 == ((uVar8 & 0x80000000) != 0);
    uVar12 = (uint)bVar6 * (uVar11 - divisor) + (uint)!bVar6 * (uVar11 + divisor);
    cVar5 = bVar6 * (uVar11 < uVar12) + !bVar6 * (uVar12 < uVar11);
    uVar8 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar11 = uVar4 | uVar8;
    uVar13 = uVar12 * 2 | (uint)((uVar9 & 0x80000000) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar12 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar13 - divisor) + (uint)!bVar6 * (uVar13 + divisor);
    cVar5 = bVar6 * (uVar13 < uVar14) + !bVar6 * (uVar14 < uVar13);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar16 = uVar4 | uVar8 & 0xfffffeff | uVar11;
    uVar13 = uVar4 | uVar8 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x40000000) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar17 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar13 = uVar13 | uVar11 & 0xfffffefe;
    uVar11 = uVar13 | uVar12;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x20000000) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar18 = uVar13 | uVar12 & 0xfffffeff | uVar11;
    uVar13 = uVar13 | uVar12 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x10000000) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar19 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar13 = uVar13 | uVar11 & 0xfffffefe;
    uVar11 = uVar13 | uVar12;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x8000000) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar20 = uVar13 | uVar12 & 0xfffffeff | uVar11;
    uVar13 = uVar13 | uVar12 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x4000000) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar21 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar13 = uVar13 | uVar11 & 0xfffffefe;
    uVar11 = uVar13 | uVar12;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x2000000) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar22 = uVar13 | uVar12 & 0xfffffeff | uVar11;
    uVar13 = uVar13 | uVar12 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x1000000) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar23 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar13 = uVar13 | uVar11 & 0xfffffefe;
    uVar11 = uVar13 | uVar12;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x800000) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar24 = uVar13 | uVar12 & 0xfffffeff | uVar11;
    uVar13 = uVar13 | uVar12 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x400000) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar25 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar13 = uVar13 | uVar11 & 0xfffffefe;
    uVar11 = uVar13 | uVar12;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x200000) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar26 = uVar13 | uVar12 & 0xfffffeff | uVar11;
    uVar13 = uVar13 | uVar12 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x100000) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar27 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar13 = uVar13 | uVar11 & 0xfffffefe;
    uVar11 = uVar13 | uVar12;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x80000) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar28 = uVar13 | uVar12 & 0xfffffeff | uVar11;
    uVar13 = uVar13 | uVar12 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x40000) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar29 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar13 = uVar13 | uVar11 & 0xfffffefe;
    uVar11 = uVar13 | uVar12;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x20000) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar30 = uVar13 | uVar12 & 0xfffffeff | uVar11;
    uVar13 = uVar13 | uVar12 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x10000) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar31 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar13 = uVar13 | uVar11 & 0xfffffefe;
    uVar11 = uVar13 | uVar12;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x8000) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar32 = uVar13 | uVar12 & 0xfffffeff | uVar11;
    uVar13 = uVar13 | uVar12 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x4000) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar33 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar13 = uVar13 | uVar11 & 0xfffffefe;
    uVar11 = uVar13 | uVar12;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x2000) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar34 = uVar13 | uVar12 & 0xfffffeff | uVar11;
    uVar13 = uVar13 | uVar12 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x1000) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar35 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar13 = uVar13 | uVar11 & 0xfffffefe;
    uVar11 = uVar13 | uVar12;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x800) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar36 = uVar13 | uVar12 & 0xfffffeff | uVar11;
    uVar13 = uVar13 | uVar12 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x400) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar37 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar13 = uVar13 | uVar11 & 0xfffffefe;
    uVar11 = uVar13 | uVar12;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x200) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar38 = uVar13 | uVar12 & 0xfffffeff | uVar11;
    uVar13 = uVar13 | uVar12 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x100) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar39 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar13 = uVar13 | uVar11 & 0xfffffefe;
    uVar11 = uVar13 | uVar12;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x80) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar40 = uVar13 | uVar12 & 0xfffffeff | uVar11;
    uVar13 = uVar13 | uVar12 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x40) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar41 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar13 = uVar13 | uVar11 & 0xfffffefe;
    uVar11 = uVar13 | uVar12;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x20) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar42 = uVar13 | uVar12 & 0xfffffeff | uVar11;
    uVar13 = uVar13 | uVar12 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 0x10) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar43 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar13 = uVar13 | uVar11 & 0xfffffefe;
    uVar11 = uVar13 | uVar12;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 8) != 0);
    bVar6 = ((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar11 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar11 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar44 = uVar13 | uVar12 & 0xfffffeff | uVar11;
    uVar13 = uVar13 | uVar12 & 0xfffffefe;
    uVar12 = uVar13 | uVar11;
    uVar15 = uVar14 * 2 | (uint)((uVar9 & 4) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    bVar7 = (bool)((byte)(uVar12 >> 9) & 1) == ((uVar14 & 0x80000000) != 0);
    uVar14 = (uint)bVar6 * (uVar15 - divisor) + (uint)!bVar6 * (uVar15 + divisor);
    cVar5 = bVar6 * (uVar15 < uVar14) + !bVar6 * (uVar14 < uVar15);
    uVar12 = (uint)(byte)(bVar7 * cVar5 + (!bVar7 && cVar5 == '\0')) << 8;
    uVar15 = uVar13 | uVar11 & 0xfffffeff | uVar12;
    uVar12 = uVar13 | uVar11 & 0xfffffefe | uVar12;
    uVar11 = uVar14 * 2 | (uint)((uVar9 & 2) != 0);
    bVar6 = ((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1);
    uVar11 = (uint)bVar6 * (uVar11 - divisor) + (uint)!bVar6 * (uVar11 + divisor);
    if (((uVar11 & 0x80000000) != 0) != bVar1) {
      uVar12 = ((int)uVar11 >> 1) << 1 | (uint)((uVar11 & 1) == 1);
      bVar6 = ((uVar11 & 0x80000000) != 0) == ((divisor & 0x80000000U) != 0);
      uVar11 = (uint)bVar6 * (uVar12 - divisor) + (uint)!bVar6 * (uVar12 + divisor);
    }
    return CONCAT44((((((((((((((((((((((((((((((((uint)(bVar3 != bVar2) << 1 |
                                                 (uint)(((byte)((uVar4 | uVar8) >> 8) & 1) ==
                                                       ((byte)((uVar4 | uVar8) >> 9) & 1))) << 1 |
                                                (uint)(((byte)(uVar16 >> 8) & 1) ==
                                                      ((byte)(uVar16 >> 9) & 1))) << 1 |
                                               (uint)(((byte)(uVar17 >> 8) & 1) ==
                                                     ((byte)(uVar17 >> 9) & 1))) << 1 |
                                              (uint)(((byte)(uVar18 >> 8) & 1) ==
                                                    ((byte)(uVar18 >> 9) & 1))) << 1 |
                                             (uint)(((byte)(uVar19 >> 8) & 1) ==
                                                   ((byte)(uVar19 >> 9) & 1))) << 1 |
                                            (uint)(((byte)(uVar20 >> 8) & 1) ==
                                                  ((byte)(uVar20 >> 9) & 1))) << 1 |
                                           (uint)(((byte)(uVar21 >> 8) & 1) ==
                                                 ((byte)(uVar21 >> 9) & 1))) << 1 |
                                          (uint)(((byte)(uVar22 >> 8) & 1) ==
                                                ((byte)(uVar22 >> 9) & 1))) << 1 |
                                         (uint)(((byte)(uVar23 >> 8) & 1) ==
                                               ((byte)(uVar23 >> 9) & 1))) << 1 |
                                        (uint)(((byte)(uVar24 >> 8) & 1) ==
                                              ((byte)(uVar24 >> 9) & 1))) << 1 |
                                       (uint)(((byte)(uVar25 >> 8) & 1) == ((byte)(uVar25 >> 9) & 1)
                                             )) << 1 |
                                      (uint)(((byte)(uVar26 >> 8) & 1) == ((byte)(uVar26 >> 9) & 1))
                                      ) << 1 | (uint)(((byte)(uVar27 >> 8) & 1) ==
                                                     ((byte)(uVar27 >> 9) & 1))) << 1 |
                                    (uint)(((byte)(uVar28 >> 8) & 1) == ((byte)(uVar28 >> 9) & 1)))
                                    << 1 | (uint)(((byte)(uVar29 >> 8) & 1) ==
                                                 ((byte)(uVar29 >> 9) & 1))) << 1 |
                                  (uint)(((byte)(uVar30 >> 8) & 1) == ((byte)(uVar30 >> 9) & 1))) <<
                                  1 | (uint)(((byte)(uVar31 >> 8) & 1) == ((byte)(uVar31 >> 9) & 1))
                                 ) << 1 | (uint)(((byte)(uVar32 >> 8) & 1) ==
                                                ((byte)(uVar32 >> 9) & 1))) << 1 |
                               (uint)(((byte)(uVar33 >> 8) & 1) == ((byte)(uVar33 >> 9) & 1))) << 1
                              | (uint)(((byte)(uVar34 >> 8) & 1) == ((byte)(uVar34 >> 9) & 1))) << 1
                             | (uint)(((byte)(uVar35 >> 8) & 1) == ((byte)(uVar35 >> 9) & 1))) << 1
                            | (uint)(((byte)(uVar36 >> 8) & 1) == ((byte)(uVar36 >> 9) & 1))) << 1 |
                           (uint)(((byte)(uVar37 >> 8) & 1) == ((byte)(uVar37 >> 9) & 1))) << 1 |
                          (uint)(((byte)(uVar38 >> 8) & 1) == ((byte)(uVar38 >> 9) & 1))) << 1 |
                         (uint)(((byte)(uVar39 >> 8) & 1) == ((byte)(uVar39 >> 9) & 1))) << 1 |
                        (uint)(((byte)(uVar40 >> 8) & 1) == ((byte)(uVar40 >> 9) & 1))) << 1 |
                       (uint)(((byte)(uVar41 >> 8) & 1) == ((byte)(uVar41 >> 9) & 1))) << 1 |
                      (uint)(((byte)(uVar42 >> 8) & 1) == ((byte)(uVar42 >> 9) & 1))) << 1 |
                     (uint)(((byte)(uVar43 >> 8) & 1) == ((byte)(uVar43 >> 9) & 1))) << 1 |
                    (uint)(((byte)(uVar44 >> 8) & 1) == ((byte)(uVar44 >> 9) & 1))) << 1 |
                    (uint)(((byte)(uVar15 >> 8) & 1) == ((byte)(uVar15 >> 9) & 1)),uVar11 + bVar1);
  }
  *(undefined4 *)PTR_DAT_06029b98 = DAT_06029b9c;
  return ZEXT48(puVar10) << 0x20;
}


void setupPowersOf2Struct(byte *powers)

{
  *powers = (byte)WORD_06026828;
  powers[1] = 0x40;
  powers[2] = 0x20;
  powers[3] = 0x10;
  powers[4] = 8;
  powers[5] = 4;
  powers[6] = 2;
  powers[7] = 1;
  return;
}


int Serial_SetPartition(SERIAL_STRUCT *param_1,char partition_number)

{
  int result;
  byte local_30 [4];
  char cStack_2c;
  undefined auStack_28 [4];
  byte local_24;
  byte bStack_23;
  char cStack_22;
  char cStack_21;
  undefined4 uStack_20;
  undefined4 uStack_1c;
  undefined2 local_18;
  undefined2 uStack_16;
  undefined4 uStack_14;
  
  cStack_2c = partition_number;
  result = serial_send_cmd__(0x11,(int)partition_number & 0xff,local_30);
  if (((int)(char)local_30[0] & 0xffU) == (int)(short)SERIAL_ERROR_0xff_2) {
    result = (int)(short)SERIAL_ERROR_0x107;
  }
  else if (((result == 0) &&
           (result = serial_read_data___(auStack_28,0x1a,PTR_DAT_06028aec), result == 0)) &&
          (result = Serial_Read_error__(local_30), result == 0)) {
    if (((int)(char)local_30[0] & 0xffU) == (int)(short)SERIAL_ERROR_0xff) {
      param_1->unit_id = local_24;
      param_1->partition_id = bStack_23;
      if (cStack_22 == '\0') {
        *(char *)(int)DAT_06028b8c = '\x10';
      }
      else {
        *(char *)(int)DAT_06028b8c = cStack_22;
      }
      param_1->field2_0x2 = (short)cStack_21 & 0xff;
      param_1->field3_0x4 = uStack_20;
      param_1->field4_0x8 = uStack_1c;
      param_1->field5_0xc = local_18;
      param_1->saved_to_im = uStack_16;
      param_1->field7_0x10 = uStack_14;
      result = 0;
    }
    else {
      result = (int)(short)SERIAL_ERROR_0x107;
    }
  }
  return result;
}


BUP_ERROR BUP_Dir(BACKUP_DEVICE device,uchar *filename,uint output_size,backup_file *file_metadata)

{
  int curr_read_offset;
  uint comment_byte;
  short sVar1;
  byte *outputBuffer;
  int iVar2;
  backup_file *output_file2;
  byte *backup_ram_start;
  uint bytes_written;
  dword *pdVar3;
  int block_offset_from_ram_start;
  BUP_ERROR i;
  dword *pdStack_44;
  backup_stat backup_stat;
  INTERNAL_METADATA **im;
  uchar *filename2;
  
  im = PTR_INTERNAL_METADATA_06027d48;
  filename2 = filename;
  if (device == DEVICE_SERIAL) {
    if ((*PTR_INTERNAL_METADATA_06027d48)->serial_connected == 0) {
      i = BUP_SUCCESS;
    }
    else {
      i = output_size & 0xffff;
      curr_read_offset = (*(code *)(PTR_LAB_06027d4c + 0x6027d1a))(filename,file_metadata,&i);
      if (curr_read_offset != 0) {
        if (curr_read_offset == PTR_DAT_06027d3c._0_2_) {
          i = -i;
        }
        else {
          i = BUP_SUCCESS;
        }
      }
    }
  }
  else {
    curr_read_offset = (*(code *)(DAT_06027d78 + 0x6027d5a))(device,0,&backup_stat);
    if (curr_read_offset == 0) {
      i = BUP_SUCCESS;
      comment_byte = SearchForSaveBlock((char *)filename2,SAVE_SEARCH);
      while ((comment_byte & 0xffff) != 0) {
        if (i < (output_size & 0xffff)) {
          bytes_written = 0;
          backup_ram_start = (*im)->backup_ram_start;
          block_offset_from_ram_start = (*im)->blockSize_in_bytes * (comment_byte & 0xffff);
                    /* Copy the filename */
          curr_read_offset = 8;
          do {
            iVar2 = curr_read_offset;
            outputBuffer = file_metadata[i].filename + bytes_written;
            bytes_written = bytes_written + 1;
            *outputBuffer = backup_ram_start[iVar2 + 1 + block_offset_from_ram_start];
            curr_read_offset = iVar2 + 2;
          } while (bytes_written < 0xb);
          file_metadata[i].filename[0xb] = 0;
                    /* Read the language */
          curr_read_offset = iVar2 + 4;
          file_metadata[i].language = backup_ram_start[iVar2 + 3 + block_offset_from_ram_start];
                    /* Read the comment */
          comment_byte = 0;
          do {
            file_metadata[i].comment[comment_byte] =
                 backup_ram_start[curr_read_offset + 1 + block_offset_from_ram_start];
            iVar2 = comment_byte + 1;
            comment_byte = comment_byte + 2;
            file_metadata[i].comment[iVar2] =
                 backup_ram_start[curr_read_offset + 3 + block_offset_from_ram_start];
            curr_read_offset = curr_read_offset + 4;
          } while (comment_byte < 10);
          file_metadata[i].comment[10] = 0;
                    /* Read the date */
          pdVar3 = &file_metadata[i].date;
          do {
            *(byte *)pdVar3 = backup_ram_start[curr_read_offset + 1 + block_offset_from_ram_start];
            *(byte *)((int)pdVar3 + 1) =
                 backup_ram_start[curr_read_offset + 3 + block_offset_from_ram_start];
            pdVar3 = (dword *)((int)pdVar3 + 2);
            curr_read_offset = curr_read_offset + 4;
          } while (pdVar3 < &file_metadata[i].datasize);
          pdVar3 = &file_metadata[i].datasize;
                    /* read the datasize
                        */
          pdStack_44 = &file_metadata[i].blocksize;
          do {
            *(byte *)pdVar3 = backup_ram_start[curr_read_offset + 1 + block_offset_from_ram_start];
            *(byte *)((int)pdVar3 + 1) =
                 backup_ram_start[curr_read_offset + 3 + block_offset_from_ram_start];
            pdVar3 = (dword *)((int)pdVar3 + 2);
            curr_read_offset = curr_read_offset + 4;
          } while (pdVar3 < pdStack_44);
          output_file2 = file_metadata + i;
                    /* Block Size = ((byte size + 29)/58) + 1 */
          sVar1 = (*(code *)(PTR_LAB_06027ed0 + 0x6027ea8))();
          *(short *)&output_file2->blocksize = sVar1 + 1;
        }
        i = i + BUP_NOT_CONNECTED;
        comment_byte = SearchForSaveBlock((char *)filename2,RESUME_SEARCH);
      }
      if ((output_size & 0xffff) < i) {
        i = -i;
      }
    }
    else {
      i = BUP_SUCCESS;
    }
  }
  return i;
}


/* 
    */

undefined4 serial_send_data2__(byte *param_1,uint size)

{
  byte bVar1;
  undefined4 uVar2;
  uint i;
  undefined2 *puVar3;
  byte *pbVar4;
  short sVar5;
  int se_0x106;
  byte *pbVar6;
  uint uVar7;
  byte *pbVar8;
  undefined2 auStack_28 [2];
  undefined2 *puStack_24;
  
                    /* sign extend 0xff03 and 0xff04 to memory map registers */
  pbVar4 = (byte *)(int)DAT_06028652;
  se_0x106 = (int)(short)SERIAL_ERROR_0x106;
  pbVar6 = (byte *)(int)DAT_06028656;
  uVar7 = (uint)DAT_06028658;
  pbVar8 = (byte *)(int)DAT_0602865a;
  puStack_24 = auStack_28;
  auStack_28[0] = (*(code *)(PTR_LAB_0602865c + 0x602862c))(param_1,size,0);
  *pbVar4 = *pbVar4 & 0xc | 0x20;
  i = 0;
  do {
    if (size <= i) {
                    /* Poll MM registers? */
      puVar3 = puStack_24 + 1;
      do {
        do {
        } while (((int)(char)*pbVar8 & 0xffU & uVar7) == 0);
        bVar1 = *(byte *)puStack_24;
        puStack_24 = (undefined2 *)((int)puStack_24 + 1);
        *pbVar6 = bVar1;
        *pbVar8 = *pbVar8 & 0x7f;
      } while (puStack_24 < puVar3);
      do {
      } while ((*pbVar8 & 4) == 0);
      *pbVar4 = *pbVar4 & 0xf;
      return 0;
    }
    sVar5 = 0;
    while (((int)(char)*pbVar8 & 0xffU & uVar7) == 0) {
      sVar5 = sVar5 + 1;
      if (sVar5 < 0) {
        uVar2 = Serial_ProcessError_(se_0x106);
        return uVar2;
      }
    }
    *pbVar6 = param_1[i];
    *pbVar8 = *pbVar8 & 0x7f;
    i = i + 1;
  } while( true );
}


BUP_ERROR BUP_SelPart(BACKUP_DEVICE device,ushort partition_number)

{
  int result;
  SERIAL_STRUCT auStack_1c;
  INTERNAL_METADATA **ppIVar1;
  
  ppIVar1 = PTR_INTERNAL_METADATA_06026738;
  if (device == DEVICE_SERIAL) {
    if ((*PTR_INTERNAL_METADATA_06026738)->serial_connected == 0) {
      return BUP_NOT_CONNECTED;
    }
    (*PTR_INTERNAL_METADATA_06026738)->serial_partition_number = (byte)partition_number;
                    /* serial_change_partition() */
    result = (*(code *)(PTR_LAB_0602673c + 0x602671a))
                       (&auStack_1c,(int)(char)(*ppIVar1)->serial_partition_number);
    if (result != 0) {
      if ((result != (short)SERIAL_ERROR_0x101) && (result != (short)SERIAL_ERROR_0x106)) {
        return ~BUP_SUCCESS;
      }
      return BUP_NOT_CONNECTED;
    }
  }
  return BUP_SUCCESS;
}


/* WARNING: Restarted to delay deadcode elimination for space: stack */

uint serial_send_cmd__(char cmd__,byte *param_2,byte *out_result__)

{
  uint uVar1;
  int i;
  byte *buf;
  byte message [8];
  byte *local_14;
  
  local_14 = param_2;
  *out_result__ = 0;
  message[0] = 0x80;
  message[1] = cmd__;
  buf = message;
  while (buf = buf + 2, buf < message + 6) {
    *buf = 0;
    buf[1] = 0;
  }
  message[3] = (char)param_2;
  if (cmd__ == 0x10) {
    for (i = 0; i < 4; i = i + 2) {
      message[i + 2] = *(byte *)((int)&local_14 + i);
      message[i + 3] = *(byte *)((int)&local_14 + i + 1);
    }
  }
  uVar1 = serial_send_data2__(message,6);
  if ((uVar1 == 0) && (uVar1 = serial_read_data___(message,6,(int)DAT_06028984), uVar1 == 0)) {
    if (message[0] == 0x20) {
      *out_result__ = message[2];
      uVar1 = (int)(char)message[3] & 0xff;
    }
    else {
      uVar1 = (uint)DAT_06028986;
    }
  }
  return uVar1;
}


/* WARNING: Globals starting with '_' overlap smaller symbols at the same address */

undefined4 MaskInterrupts_ABus2_(void)

{
  undefined4 uVar1;
  
  uVar1 = *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_060284cc;
  (**(code **)PTR_PTR_SetOnChipReg__060284d0)(0xffffffff);
  *PTR_0x2400aaab = (char)DATA_0xAA;
  *PTR_0x24005555 = 0x55;
  *PTR_0x2400aaab = (char)_DATA_0x00;
  (**(code **)PTR_PTR_SetOnChipReg__060284d0)(uVar1);
  uVar1 = (*(code *)(PTR_DAT_060284e0 + 0x60284bc))();
  return uVar1;
}


uint somethingSerial3__(int param_1,int param_2,byte *param_3)

{
  undefined *puVar1;
  uint uVar2;
  byte *pbVar3;
  byte *pbVar4;
  int iVar5;
  uint uVar6;
  byte local_60 [4];
  char acStack_5c [4];
  byte *pbStack_58;
  int iStack_54;
  int iStack_50;
  byte local_4c;
  byte local_4b [37];
  byte abStack_26 [10];
  
  puVar1 = PTR_INTERNAL_METADATA_060290c4;
  uVar6 = (uint)DAT_060290be;
  pbStack_58 = param_3;
  iStack_54 = param_2;
  iStack_50 = param_1;
  uVar2 = serial_send_cmd__(0x40,0,local_60);
  if (((int)(char)local_60[0] & 0xffU) == uVar6) {
    uVar2 = (uint)PTR_DAT_060290c0._0_2_;
  }
  else if (uVar2 == 0) {
    local_4c = 0x40;
    pbVar3 = &local_4c;
    while (pbVar3 = pbVar3 + 1, pbVar3 < abStack_26) {
      *pbVar3 = 0;
    }
    local_4b[14] = 0xc;
    for (uVar2 = 0; uVar2 < 0xb; uVar2 = uVar2 + 1) {
      local_4b[uVar2 + 3] = *(byte *)(iStack_50 + uVar2);
      if (*(byte *)(iStack_50 + uVar2) == 0) {
        local_4b[14] = (byte)uVar2;
        uVar2 = 0xb;
      }
    }
    pbVar3 = pbStack_58;
    for (pbVar4 = local_4b + 0x1f; pbVar4 < local_4b + 0x23; pbVar4 = pbVar4 + 2) {
      *pbVar4 = *pbVar3;
      pbVar4[1] = pbVar3[1];
      pbVar3 = pbVar3 + 2;
    }
    uVar2 = serial_send_data2__(&local_4c,0x26);
    if ((uVar2 == 0) && (uVar2 = serial_read_data___(&local_4c,6,PTR_DAT_0602916c), uVar2 == 0)) {
      if (local_4b[2] == '\0') {
        acStack_5c[0] = '\0';
        iVar5 = 0;
        while (((int)acStack_5c[0] & 0xffU) != uVar6) {
          uVar2 = something_serial5((*(uint *)(*(int *)puVar1 + 0x68) >> 5) * iVar5 * 0x24 +
                                    iStack_54,pbStack_58,acStack_5c);
          if (uVar2 != 0) {
            if (uVar2 != (int)PTR_DAT_06029168._0_2_) {
              return uVar2;
            }
            serial_send_cmd__(0,0,local_60);
            return uVar2;
          }
          uVar2 = serial_send_cmd__(0,0,local_60);
          if (uVar2 != 0) {
            return uVar2;
          }
          iVar5 = iVar5 + 1;
        }
        if (((int)(char)local_60[0] & 0xffU) == uVar6) {
          uVar2 = 0;
        }
        else {
          uVar2 = (uint)DAT_060291a0;
        }
      }
      else {
        uVar2 = (int)(char)local_4b[2] & 0xff;
      }
    }
  }
  return uVar2;
}


uint serial_deleteFile(char *param_1)

{
  uint uVar1;
  char *pcVar2;
  char *pcVar3;
  byte local_3c [4];
  char *pcStack_38;
  byte local_34;
  char local_33 [37];
  char acStack_e [6];
  
  pcStack_38 = param_1;
  uVar1 = serial_send_cmd__(0x30,0,local_3c);
  if (((int)(char)local_3c[0] & 0xffU) == (int)DAT_06028bee) {
    uVar1 = (uint)DAT_06028bf0;
  }
  else if (uVar1 == 0) {
    local_34 = 0x40;
    pcVar2 = local_33;
    do {
      *pcVar2 = '\0';
      pcVar2 = pcVar2 + 1;
    } while (pcVar2 < acStack_e);
    pcVar3 = local_33 + 3;
    pcVar2 = pcStack_38;
    do {
      *pcVar3 = *pcVar2;
      pcVar3 = pcVar3 + 1;
      pcVar2 = pcVar2 + 1;
    } while (pcVar3 < local_33 + 0xe);
    uVar1 = serial_send_data2__(&local_34,0x26);
    if ((uVar1 == 0) && (uVar1 = serial_read_data___(&local_34,6,PTR_DAT_06028c7c), uVar1 == 0)) {
      if (local_33[2] == '\0') {
        uVar1 = Serial_Read_error__(local_3c);
        if (uVar1 == 0) {
          if (((int)(char)local_3c[0] & 0xffU) == (int)DAT_06028c76) {
            uVar1 = 0;
          }
          else {
            uVar1 = (uint)PTR_DAT_06028c78._0_2_;
          }
        }
      }
      else {
        uVar1 = (int)local_33[2] & 0xff;
      }
    }
  }
  return uVar1;
}


undefined4 MaskInterrupts_ABus_(void)

{
  undefined4 value_0xfffff17c;
  
  value_0xfffff17c = *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_060284cc;
  (**(code **)PTR_PTR_SetOnChipReg__060284d0)(0xffffffff);
  *PTR_0x2400aaab = (char)DATA_0xAA;
  *PTR_0x24005555 = 0x55;
  *PTR_0x2400aaab = (char)0x90;
  (**(code **)PTR_PTR_SetOnChipReg__060284d0)(value_0xfffff17c);
  value_0xfffff17c = (*(code *)(PTR_Onchip_DMA0R_2_060284dc + 0x602847e))();
  return value_0xfffff17c;
}


/* WARNING: Unknown calling convention */

uint software_divide_(int divisor,int dividend)

{
  char cVar1;
  bool bVar2;
  bool bVar3;
  bool bVar4;
  byte bVar5;
  uint uVar6;
  uint in_r1;
  uint uVar7;
  uint uVar9;
  uint uVar11;
  uint uVar12;
  uint uVar13;
  uint uVar14;
  uint uVar15;
  uint uVar16;
  uint uVar17;
  uint uVar18;
  uint uVar19;
  uint uVar20;
  uint uVar21;
  uint uVar22;
  uint uVar23;
  uint uVar24;
  uint uVar25;
  uint uVar26;
  uint uVar27;
  uint uVar28;
  uint uVar29;
  uint uVar30;
  uint uVar31;
  uint uVar32;
  uint uVar33;
  uint uVar34;
  uint uVar35;
  uint uVar36;
  uint uVar37;
  uint uVar38;
  uint uVar39;
  uint uVar40;
  uint uVar8;
  uint uVar10;
  
  if (divisor != 0) {
    uVar7 = (uint)((in_r1 & 0x80000000) != 0);
    uVar8 = uVar7 - divisor;
    bVar4 = uVar8 <= uVar7;
    uVar12 = in_r1 << 2;
    bVar3 = (uVar8 & 0x80000000) == 0;
    uVar7 = uVar8 * 2 | (uint)((in_r1 & 0x40000000) != 0);
    uVar8 = (uint)bVar4 * (uVar7 - divisor) + (uint)!bVar4 * (uVar7 + divisor);
    cVar1 = bVar4 * (uVar7 < uVar8) + !bVar4 * (uVar8 < uVar7);
    bVar5 = bVar3 * cVar1 + (!bVar3 && cVar1 == '\0');
    uVar7 = (uint)bVar5 << 8;
    uVar9 = uVar8 * 2 | (uint)((uVar12 & 0x80000000) != 0);
    bVar3 = (bVar5 & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar8 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar9 - divisor) + (uint)!bVar3 * (uVar9 + divisor);
    cVar1 = bVar3 * (uVar9 < uVar10) + !bVar3 * (uVar10 < uVar9);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar13 = uVar7 & 0xfffffeff | uVar8;
    uVar6 = uVar7 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x40000000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar14 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x20000000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar15 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x10000000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar16 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x8000000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar17 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x4000000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar18 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x2000000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar19 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x1000000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar20 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x800000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar21 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x400000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar22 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x200000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar23 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x100000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar24 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x80000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar25 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x40000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar26 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x20000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar27 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x10000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar28 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x8000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar29 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x4000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar30 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x2000) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar31 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x1000) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar32 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x800) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar33 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x400) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar34 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x200) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar35 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x100) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar36 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x80) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar37 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x40) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar38 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x20) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar39 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x10) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar40 = uVar6 | uVar8 & 0xfffffeff | uVar9;
    uVar6 = uVar6 | uVar8 & 0xfffffefe;
    uVar8 = uVar6 | uVar9;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 8) != 0);
    bVar3 = ((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar3 * (uVar11 - divisor) + (uint)!bVar3 * (uVar11 + divisor);
    cVar1 = bVar3 * (uVar11 < uVar10) + !bVar3 * (uVar10 < uVar11);
    uVar8 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    uVar11 = uVar6 | uVar9 & 0xfffffeff | uVar8;
    uVar6 = uVar6 | uVar9 & 0xfffffefe;
    uVar9 = uVar6 | uVar8;
    uVar12 = uVar10 * 2 | (uint)((uVar12 & 4) != 0);
    bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
    bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar9 = (uint)bVar3 * (uVar12 - divisor) + (uint)!bVar3 * (uVar12 + divisor);
    cVar1 = bVar3 * (uVar12 < uVar9) + !bVar3 * (uVar9 < uVar12);
    uVar8 = uVar6 | uVar8 & 0xfffffeff |
            (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
    return (((((((((((((((((((((((((((((((uint)bVar4 << 1 |
                                        (uint)((bVar5 & 1) == ((byte)(uVar7 >> 9) & 1))) << 1 |
                                       (uint)(((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1)
                                             )) << 1 |
                                      (uint)(((byte)(uVar14 >> 8) & 1) == ((byte)(uVar14 >> 9) & 1))
                                      ) << 1 | (uint)(((byte)(uVar15 >> 8) & 1) ==
                                                     ((byte)(uVar15 >> 9) & 1))) << 1 |
                                    (uint)(((byte)(uVar16 >> 8) & 1) == ((byte)(uVar16 >> 9) & 1)))
                                    << 1 | (uint)(((byte)(uVar17 >> 8) & 1) ==
                                                 ((byte)(uVar17 >> 9) & 1))) << 1 |
                                  (uint)(((byte)(uVar18 >> 8) & 1) == ((byte)(uVar18 >> 9) & 1))) <<
                                  1 | (uint)(((byte)(uVar19 >> 8) & 1) == ((byte)(uVar19 >> 9) & 1))
                                 ) << 1 | (uint)(((byte)(uVar20 >> 8) & 1) ==
                                                ((byte)(uVar20 >> 9) & 1))) << 1 |
                               (uint)(((byte)(uVar21 >> 8) & 1) == ((byte)(uVar21 >> 9) & 1))) << 1
                              | (uint)(((byte)(uVar22 >> 8) & 1) == ((byte)(uVar22 >> 9) & 1))) << 1
                             | (uint)(((byte)(uVar23 >> 8) & 1) == ((byte)(uVar23 >> 9) & 1))) << 1
                            | (uint)(((byte)(uVar24 >> 8) & 1) == ((byte)(uVar24 >> 9) & 1))) << 1 |
                           (uint)(((byte)(uVar25 >> 8) & 1) == ((byte)(uVar25 >> 9) & 1))) << 1 |
                          (uint)(((byte)(uVar26 >> 8) & 1) == ((byte)(uVar26 >> 9) & 1))) << 1 |
                         (uint)(((byte)(uVar27 >> 8) & 1) == ((byte)(uVar27 >> 9) & 1))) << 1 |
                        (uint)(((byte)(uVar28 >> 8) & 1) == ((byte)(uVar28 >> 9) & 1))) << 1 |
                       (uint)(((byte)(uVar29 >> 8) & 1) == ((byte)(uVar29 >> 9) & 1))) << 1 |
                      (uint)(((byte)(uVar30 >> 8) & 1) == ((byte)(uVar30 >> 9) & 1))) << 1 |
                     (uint)(((byte)(uVar31 >> 8) & 1) == ((byte)(uVar31 >> 9) & 1))) << 1 |
                    (uint)(((byte)(uVar32 >> 8) & 1) == ((byte)(uVar32 >> 9) & 1))) << 1 |
                   (uint)(((byte)(uVar33 >> 8) & 1) == ((byte)(uVar33 >> 9) & 1))) << 1 |
                  (uint)(((byte)(uVar34 >> 8) & 1) == ((byte)(uVar34 >> 9) & 1))) << 1 |
                 (uint)(((byte)(uVar35 >> 8) & 1) == ((byte)(uVar35 >> 9) & 1))) << 1 |
                (uint)(((byte)(uVar36 >> 8) & 1) == ((byte)(uVar36 >> 9) & 1))) << 1 |
               (uint)(((byte)(uVar37 >> 8) & 1) == ((byte)(uVar37 >> 9) & 1))) << 1 |
              (uint)(((byte)(uVar38 >> 8) & 1) == ((byte)(uVar38 >> 9) & 1))) << 1 |
             (uint)(((byte)(uVar39 >> 8) & 1) == ((byte)(uVar39 >> 9) & 1))) << 1 |
            (uint)(((byte)(uVar40 >> 8) & 1) == ((byte)(uVar40 >> 9) & 1))) << 1 |
           (uint)(((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1))) << 1 |
           (uint)(((byte)(uVar8 >> 8) & 1) == ((byte)(uVar8 >> 9) & 1));
  }
  *(undefined4 *)PTR_DAT_06029ad0 = DAT_06029ad4;
  return 0;
}


BUP_ERROR ReadByBlockId(word fileID,byte *outBuf)

{
  byte *backup_ram_start;
  uint j;
  int data_index;
  INTERNAL_METADATA *im2;
  ushort *next_block_id;
  short *saved_sat_blocks;
  int block_type_flag;
  uint bytes_read;
  int i;
  uint curBlock;
  int block_offset;
  dword save_size;
  ushort auStack_24 [2];
  ushort *puStack_20;
  INTERNAL_METADATA **im;
  
  im = PTR_INTERNAL_METADATA_06027a90;
  block_type_flag = 0;
  curBlock = 1;
  bytes_read = 0;
  i = 0;
  *(*PTR_INTERNAL_METADATA_06027a90)->sat_blocks = fileID;
  do {
    if ((*im)->sat_blocks[i] == 0) {
      return BUP_SUCCESS;
    }
    j = 0;
    if ((*im)->totalBlocks < ((int)(*im)->sat_blocks[i] & 0xffffU)) {
      return BUP_BROKEN;
    }
    im2 = *im;
    block_offset = ((int)im2->sat_blocks[i] & 0xffffU) * im2->blockSize_in_bytes;
    backup_ram_start = im2->backup_ram_start;
    if (block_type_flag == 0) {
      block_type_flag = 1;
                    /* Read the save size from the SAT Header
                        */
      j = 0x3c;
      puStack_20 = auStack_24;
      next_block_id = (ushort *)&save_size;
      do {
        *(byte *)next_block_id = backup_ram_start[j + 1 + block_offset];
        *(byte *)((int)next_block_id + 1) = backup_ram_start[j + 3 + block_offset];
        next_block_id = next_block_id + 1;
        j = j + 4;
      } while (next_block_id < puStack_20);
SAT_CONT_BLOCK:
      if (j == 0) {
        j = 8;
      }
                    /* Parse the sat block lists */
      for (; (j < (*im)->blockSize_in_bytes && ((*im)->sat_blocks[curBlock - 1] != 0));
          curBlock = curBlock + 1) {
        saved_sat_blocks = (*im)->sat_blocks;
        *(byte *)(saved_sat_blocks + curBlock) = backup_ram_start[j + 1 + block_offset];
        data_index = j + 3;
        j = j + 4;
        *(byte *)((int)(saved_sat_blocks + curBlock) + 1) =
             backup_ram_start[data_index + block_offset];
      }
      if ((*im)->sat_blocks[curBlock - 1] == 0) {
        block_type_flag = 2;
SAT_END_BLOCK:
        if (j == 0) {
          j = 8;
        }
                    /* Copy save data
                        */
        for (; (j < (*im)->blockSize_in_bytes && (bytes_read < save_size));
            bytes_read = bytes_read + 1) {
          data_index = j + 1;
          j = j + 2;
          outBuf[bytes_read] = backup_ram_start[data_index + block_offset];
        }
      }
    }
    else {
      if (block_type_flag == 1) goto SAT_CONT_BLOCK;
      if (block_type_flag == 2) goto SAT_END_BLOCK;
    }
    i = i + 1;
    if ((*im)->totalBlocks < curBlock) {
      return BUP_BROKEN;
    }
  } while( true );
}


uint Serial_Read_error__(char *outBuf)

{
  uint result;
  char buf [4];
  
  result = serial_read_data___(buf,6,PTR_DAT_060289e4);
  if (result != 0) {
    return result;
  }
  if (buf[0] != ' ') {
    return (int)(short)SERIAL_ERROR_0xff;
  }
  *outBuf = buf[2];
  return (int)buf[3] & 0xff;
}


/* WARNING: Could not reconcile some variable overlaps */

int serial_read_file2(int param_1,int *param_2,byte *param_3,char param_4)

{
  byte bVar1;
  undefined *puVar2;
  undefined *puVar3;
  int iVar4;
  uint uVar5;
  undefined *puVar6;
  undefined *puVar7;
  byte *pbVar8;
  byte *pbVar9;
  undefined4 local_50;
  int iStack_4c;
  int *piStack_48;
  int iStack_44;
  byte *pbStack_40;
  byte *pbStack_3c;
  char cStack_38;
  int *piStack_34;
  byte *pbStack_30;
  undefined4 *puStack_2c;
  int iStack_28;
  
  puVar2 = PTR_DAT_06029250;
  puStack_2c = &local_50;
  pbVar8 = (byte *)(int)DAT_06029248;
  pbVar9 = pbVar8 + -1;
  piStack_48 = &iStack_4c;
  *(undefined4 *)(*(int *)PTR_INTERNAL_METADATA_06029254 + 0x6c) =
       *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_06029258;
  iStack_44 = param_1;
  pbStack_3c = param_3;
  cStack_38 = param_4;
  piStack_34 = param_2;
  (**(code **)PTR_PTR_SetOnChipReg__0602925c)(0xffffffff);
  *(byte *)(int)DAT_0602924a = *(byte *)(int)DAT_0602924a & 0xc | 0x12;
  *pbVar9 = *pbVar9 & 0xbf;
  iStack_4c = 0;
  iStack_28 = 0;
  uVar5 = 0;
  pbStack_40 = (byte *)((int)&local_50 + 2);
  pbStack_30 = (byte *)((int)piStack_48 + 2);
  piStack_48 = (int *)((int)piStack_48 + 3);
  puVar7 = PTR_DAT_06029260;
  do {
    puVar3 = PTR_DAT_060292e8;
    if (iStack_4c + 8U <= uVar5) {
      *(byte *)(int)DAT_060293e2 = *(byte *)(int)DAT_060293e2 & 0xf;
      *pbVar9 = 0;
      (**(code **)PTR_PTR_SetOnChipReg__060293e8)
                (*(undefined4 *)(*(int *)PTR_INTERNAL_METADATA_060293ec + 0x6c));
      local_50 = local_50 << 4;
      if (*(short *)puStack_2c == 0) {
        if (iStack_28 == 0) {
          iVar4 = 0;
        }
        else {
          iVar4 = (int)DAT_060293e6;
        }
      }
      else {
        iVar4 = Serial_ProcessError_((int)DAT_060293e4);
      }
      return iVar4;
    }
    puVar6 = (undefined *)0x0;
    do {
      puVar6 = puVar6 + 1;
      if (puVar7 < puVar6) {
        iVar4 = Serial_ProcessError_((int)DAT_0602924c);
        return iVar4;
      }
      if ((*pbVar9 & 8) != 0) {
        iVar4 = Serial_ProcessError_((int)DAT_0602924e);
        return iVar4;
      }
      if ((*pbVar9 & 0x10) != 0) {
        iVar4 = Serial_ProcessError_((int)DAT_060292e2);
        return iVar4;
      }
      if ((*pbVar9 & 0x20) != 0) {
        iVar4 = Serial_ProcessError_((int)PTR_DAT_060292e4._0_2_);
        return iVar4;
      }
    } while ((*pbVar9 & 0x40) == 0);
    if (uVar5 == 0) {
      local_50 = (uint)*pbVar8 << 0x10;
    }
    else if (uVar5 == 1) {
      *pbStack_40 = *pbVar8;
      *pbStack_3c = *pbStack_40;
      local_50 = local_50 ^ (uint)PTR_DAT_060292ec;
    }
    else {
      bVar1 = *pbVar8;
      local_50 = local_50 & 0xffffff00 | (uint)bVar1;
      if (uVar5 == 2) {
        *pbStack_30 = bVar1;
      }
      else if (uVar5 == 3) {
        *(byte *)piStack_48 = bVar1;
        *piStack_34 = iStack_4c;
      }
      else if ((3 < uVar5) && (uVar5 < iStack_4c + 4U)) {
        if (cStack_38 == '\0') {
          *(byte *)(iStack_44 + uVar5 + -4) = bVar1;
        }
        else if (*(byte *)(iStack_44 + uVar5 + -4) != bVar1) {
          iStack_28 = 1;
        }
      }
      local_50 = local_50 << 4;
      local_50._0_1_ = (char)(local_50 >> 0x18);
      if (local_50._0_1_ != '\0') {
        local_50 = local_50 ^ ((int)local_50._0_1_ & 0xffU) * (int)puVar2;
      }
      local_50 = local_50 << 4;
      local_50._0_1_ = (char)(local_50 >> 0x18);
      if (local_50._0_1_ != '\0') {
        local_50 = local_50 ^ ((int)local_50._0_1_ & 0xffU) * (int)puVar2;
      }
    }
    *pbVar9 = *pbVar9 & 0xbf;
    uVar5 = uVar5 + 1;
    puVar7 = puVar3;
  } while( true );
}


int something_serial5(int param_1,int *param_2,char *param_3)

{
  uint uVar1;
  uint uVar2;
  int iVar3;
  uint uVar4;
  undefined *puVar5;
  char *pcVar6;
  int iVar7;
  char *pcVar8;
  byte *pbVar9;
  uint local_64;
  uint *puStack_60;
  uint uStack_5c;
  int iStack_58;
  uint *puStack_54;
  char *pcStack_50;
  undefined *puStack_4c;
  int *piStack_48;
  char *pcStack_44;
  int *piStack_40;
  char *pcStack_3c;
  char *pcStack_38;
  int iStack_34;
  int iStack_30;
  int iStack_2c;
  uint *puStack_28;
  
  puStack_60 = &local_64;
  puStack_28 = &local_64;
  pcVar6 = (char *)(int)DAT_06028d22;
  pbVar9 = (byte *)(pcVar6 + -1);
  puStack_54 = &uStack_5c;
  iStack_30 = param_1 + 0x18;
  iStack_2c = param_1 + 0x1c;
  iStack_34 = param_1 + 0x20;
  piStack_40 = &iStack_58;
  *(undefined4 *)(*(int *)PTR_INTERNAL_METADATA_06028d28 + 0x6c) =
       *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_06028d2c;
  piStack_48 = param_2;
  pcStack_44 = param_3;
  (**(code **)PTR_PTR_SetOnChipReg__06028d30)(0xffffffff);
  *(byte *)(int)DAT_06028d24 = *(byte *)(int)DAT_06028d24 & 0xc | 0x12;
  *pbVar9 = *pbVar9 & 0xbf;
  uStack_5c = 0;
  iStack_58 = 0;
  iVar3 = 0;
  uVar1 = 0;
  iVar7 = 0;
  puStack_4c = PTR_DAT_06028d34;
  uVar4 = 0;
  pcStack_38 = (char *)((int)puStack_60 + 1);
  pcStack_50 = (char *)((int)puStack_60 + 2);
  pcVar8 = (char *)((int)puStack_60 + 3);
  pcStack_3c = (char *)((int)puStack_54 + 2);
  puStack_54 = (uint *)((int)puStack_54 + 3);
  do {
    if (uStack_5c + 8 <= uVar4) {
      *(byte *)(int)DAT_06029018 = *(byte *)(int)DAT_06029018 & 0xf;
      *pbVar9 = 0;
      (**(code **)PTR_PTR_SetOnChipReg__06029020)
                (*(undefined4 *)(*(int *)PTR_INTERNAL_METADATA_06029024 + 0x6c));
      local_64 = local_64 << 4;
      if (*(short *)puStack_28 == 0) {
        if (iStack_58 == 0) {
          *piStack_48 = iVar7;
          iVar3 = 0;
        }
        else {
          iVar3 = (int)PTR_DAT_0602901c._0_2_;
          *piStack_48 = iStack_58;
        }
      }
      else {
        iVar3 = Serial_ProcessError_((int)DAT_0602901a);
      }
      return iVar3;
    }
    puVar5 = (undefined *)0x0;
    do {
      puVar5 = puVar5 + 1;
      if (puStack_4c < puVar5) {
        iVar3 = Serial_ProcessError_((int)DAT_06028db6);
        return iVar3;
      }
      if ((*pbVar9 & 8) != 0) {
        iVar3 = Serial_ProcessError_((int)DAT_06028db8);
        return iVar3;
      }
      if ((*pbVar9 & 0x10) != 0) {
        iVar3 = Serial_ProcessError_((int)DAT_06028dba);
        return iVar3;
      }
      if ((*pbVar9 & 0x20) != 0) {
        iVar3 = Serial_ProcessError_((int)DAT_06028dbc);
        return iVar3;
      }
    } while ((*pbVar9 & 0x40) == 0);
    puStack_4c = (undefined *)(int)DAT_06028dbe;
    if (uVar4 == 0) {
      local_64 = 0;
      *pcStack_38 = *pcVar6;
    }
    else if (uVar4 == 1) {
      *pcStack_50 = *pcVar6;
      *pcStack_44 = *pcStack_50;
      local_64 = local_64 ^ (uint)PTR_DAT_06028dc0;
    }
    else {
      *pcVar8 = *pcVar6;
      if (uStack_5c == 4) {
        if (uVar4 < 8) {
          *(char *)((int)piStack_40 + (uVar4 - 4)) = *pcVar8;
        }
      }
      else if (iVar3 == 0) {
        if (uVar4 == 2) {
          *pcStack_3c = *pcVar8;
        }
        else if (uVar4 == 3) {
          *(char *)puStack_54 = *pcVar8;
          iVar3 = 1;
          uVar1 = 0;
        }
      }
      else if (iVar3 == 1) {
        *(char *)(uVar1 + iVar7 * 0x24 + param_1) = *pcVar8;
        uVar1 = uVar1 + 1;
        if (10 < uVar1) {
          iVar3 = 2;
          *(undefined *)(iVar7 * 0x24 + param_1 + 0xb) = 0;
          uVar1 = 0;
        }
      }
      else if (iVar3 == 2) {
        if (uVar1 == 10) {
          *(char *)(iVar7 * 0x24 + param_1 + 0x17) = *pcVar8;
        }
        else {
          *(char *)(uVar1 + iVar7 * 0x24 + param_1 + 0xc) = *pcVar8;
        }
        uVar1 = uVar1 + 1;
        if (10 < uVar1) {
          iVar3 = 3;
          *(undefined *)(iVar7 * 0x24 + param_1 + 0x16) = 0;
          uVar1 = 0;
        }
      }
      else if (iVar3 == 3) {
        uVar2 = uVar1 + 1;
        *(char *)(uVar1 + iStack_34) = *pcVar8;
        uVar1 = uVar2;
        if (1 < uVar2) {
          iVar3 = 4;
          uVar1 = 0;
        }
      }
      else if (iVar3 == 4) {
        uVar2 = uVar1 + 1;
        *(char *)(uVar1 + iStack_30) = *pcVar8;
        uVar1 = uVar2;
        if (3 < uVar2) {
          iVar3 = 5;
          uVar1 = 0;
        }
      }
      else if (iVar3 == 5) {
        uVar2 = uVar1 + 1;
        *(char *)(uVar1 + iStack_2c) = *pcVar8;
        uVar1 = uVar2;
        if (3 < uVar2) {
          if (uVar4 < uStack_5c) {
            iVar3 = 1;
          }
          else {
            iVar3 = 6;
          }
          iVar7 = iVar7 + 1;
          iStack_34 = iVar7 * 0x24 + param_1;
          iStack_30 = iStack_34 + 0x18;
          iStack_2c = iStack_34 + 0x1c;
          iStack_34 = iStack_34 + 0x20;
          uVar1 = 0;
        }
      }
      local_64 = local_64 << 4;
      if (*(char *)puStack_60 != '\0') {
        local_64 = local_64 ^ ((int)*(char *)puStack_60 & 0xffU) * (int)PTR_DAT_06028f9c;
      }
      local_64 = local_64 << 4;
      if (*(char *)puStack_60 != '\0') {
        local_64 = local_64 ^ ((int)*(char *)puStack_60 & 0xffU) * (int)PTR_DAT_06028f9c;
      }
    }
    *pbVar9 = *pbVar9 & 0xbf;
    uVar4 = uVar4 + 1;
  } while( true );
}


void InitBackupRamFormatString(char *backupFormatStr)

{
  *backupFormatStr = 'B';
  backupFormatStr[1] = 'a';
  backupFormatStr[2] = 'c';
  backupFormatStr[3] = 'k';
  backupFormatStr[4] = 'U';
  backupFormatStr[5] = 'p';
  backupFormatStr[6] = 'R';
  backupFormatStr[7] = 'a';
  backupFormatStr[8] = 'm';
  backupFormatStr[9] = ' ';
  backupFormatStr[10] = 'F';
  backupFormatStr[0xb] = 'o';
  backupFormatStr[0xc] = 'r';
  backupFormatStr[0xd] = 'm';
  backupFormatStr[0xe] = 'a';
  backupFormatStr[0xf] = 't';
  return;
}


/* WARNING: Could not reconcile some variable overlaps */

void DeleteFileByID(uint block)

{
  byte *backup_ram_start;
  uint i;
  int block_offset;
  dword tag;
  byte *pbStack_2c;
  byte *pbStack_28;
  undefined4 uStack_24;
  byte *pbStack_20;
  INTERNAL_METADATA **im;
  
  im = PTR_INTERNAL_METADATA_06027c94;
  block_offset = (*PTR_INTERNAL_METADATA_06027c94)->blockSize_in_bytes * (block & 0xffff);
  backup_ram_start = (*PTR_INTERNAL_METADATA_06027c94)->backup_ram_start;
  pbStack_2c = (byte *)((int)&tag + 1);
  pbStack_28 = (byte *)((int)&tag + 2);
  pbStack_20 = (byte *)((int)&tag + 3);
                    /* Remove high bit from tag */
  tag = CONCAT31(CONCAT21(CONCAT11(backup_ram_start[block_offset + 1],
                                   backup_ram_start[block_offset + 3]),
                          backup_ram_start[block_offset + 5]),backup_ram_start[block_offset + 7]) &
        0x7fffffff;
  if ((*PTR_INTERNAL_METADATA_06027c94)->cart_format_flag_ != 0) {
    tag = tag + 1 & 0x7f;
  }
                    /* TODO: what happens when flag_format is 1? presumably this is a cart */
  if ((*PTR_INTERNAL_METADATA_06027c94)->cart_format_flag_ == 1) {
    uStack_24 = *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_06027c98;
    (**(code **)PTR_PTR_SetOnChipReg__06027c9c)(0xffffffff);
  }
                    /* Write new tag (with high bit off) */
  backup_ram_start[block_offset + 1] = tag._0_1_;
  backup_ram_start[block_offset + 3] = *pbStack_2c;
  backup_ram_start[block_offset + 5] = *pbStack_28;
  backup_ram_start[block_offset + 7] = *pbStack_20;
  i = 8;
  if ((*im)->cart_format_flag_ == 1) {
    for (; i < (*im)->blockSize_in_bytes; i = i + 2) {
      backup_ram_start[i + 1 + block_offset] = 0;
    }
    (*(code *)(DAT_06027d40 + 0x6027cba))();
    (**(code **)PTR_PTR_SetOnChipReg__06027d44)(uStack_24);
  }
  return;
}


/* WARNING: Could not reconcile some variable overlaps */

BUP_ERROR BUP_Stat(BACKUP_DEVICE device,uint datasize,backup_stat *output_stat)

{
  int result;
  dword totalBlocks;
  byte *psat_blocks;
  uint used_block;
  uint j;
  INTERNAL_METADATA *im2;
  uint i;
  undefined2 cur_sat_block;
  undefined2 *puStack_64;
  word puStack_64_00;
  byte *cur_block_address;
  byte *sat_block_high;
  int number_of_sat_blocks_in_sat_list;
  uint datanum;
  int number_of_sat_blocks;
  uint uStack_4c;
  int reserved_blocks;
  int cart_remaining_blocks;
  byte powers_of_two [8];
  undefined auStack_38 [4];
  dword dStack_34;
  dword dStack_30;
  short sStack_2c;
  dword sat_block_low;
  INTERNAL_METADATA **im;
  INTERNAL_METADATA **pIVar1;
  bool end_sat_blocks;
  
  im = PTR_INTERNAL_METADATA_06026b14;
  puStack_64 = (undefined2 *)(uint)device;
  uStack_4c = datasize;
  if (puStack_64 != (undefined2 *)0x2) {
    setupPowersOf2Struct(powers_of_two);
    if (puStack_64 == (undefined2 *)DEVICE_INTERNAL) {
      if ((*im)->internal_connected == 0) {
        return BUP_NOT_CONNECTED;
      }
      output_stat->totalsize = g_TotalSize;
      totalBlocks = (dword)(short)g_TotalBlocks;
      output_stat->totalblock = totalBlocks;
      output_stat->blocksize = 0x40;
      (*im)->totalBlocks = totalBlocks;
      (*im)->blockSize = 0x40;
      (*im)->blockSize_in_bytes = (int)blocksize_in_bytes;
      cart_remaining_blocks = (int)usuable_blocks__;
      (*im)->backup_ram_start = backup_ram_start_;
      (*im)->offset_of_filedata_in_blocks = 2;
      (*im)->cart_format_flag_ = 0;
      (*im)->backup_ram_bad_blocks_bitmap = (dword)backup_ram_start_plus_80;
      result = checkFormatted();
      if (result != 0) {
        return BUP_NOT_FORMATTED;
      }
    }
    else {
      if (puStack_64 != (undefined2 *)DEVICE_CARTRIDGE) {
        return BUP_NOT_CONNECTED;
      }
      if ((*im)->cartridge_connected == 0) {
        return BUP_NOT_CONNECTED;
      }
      (*im)->totalBlocks = (*im)->totalBlocks_cart;
      (*im)->blockSize = (*im)->blockSize_cart;
      (*im)->offset_of_filedata_in_blocks = (*im)->cartridge_offset_to_data_in_blocks;
      (*im)->cart_format_flag_ = (*im)->cartridge_flag_2;
      (*im)->backup_ram_start = BACKUP_CART_START;
      (*im)->blockSize_in_bytes = (*im)->blockSize << 1;
      im2 = *im;
      cart_remaining_blocks = im2->totalBlocks - im2->offset_of_filedata_in_blocks;
      im2->backup_ram_bad_blocks_bitmap = (dword)(im2->backup_ram_start + im2->blockSize_in_bytes);
      output_stat->totalsize = (*im)->totalBlocks * (*im)->blockSize;
      output_stat->totalblock = (*im)->totalBlocks;
      output_stat->blocksize = (*im)->blockSize;
      result = checkFormatted();
      if (result != 0) {
        return BUP_NOT_FORMATTED;
      }
    }
    reserved_blocks = (*(code *)(PTR_DAT_06026c20 + 0x6026bda))();
    cur_block_address = (*im)->backup_ram_start + (*im)->blockSize_in_bytes * 2;
    sat_block_high = (byte *)((int)&cur_sat_block + 1);
    used_block = 0;
    puStack_64 = &cur_sat_block;
    for (i = (*im)->offset_of_filedata_in_blocks; i < (*im)->totalBlocks; i = i + 1) {
                    /* Check if block is busy (tag is negative e.g. <= 0x80 00 00 00) and not on the
                       bad block bitmap */
      if (((char)cur_block_address[1] < 0) &&
         ((*(byte *)((i >> 3) * 2 + (*PTR_INTERNAL_METADATA_06026d04)->backup_ram_bad_blocks_bitmap
                    + 1) & powers_of_two[i & 7]) == 0)) {
        used_block = used_block + 1;
        j = 0x22;
        end_sat_blocks = true;
        number_of_sat_blocks_in_sat_list = 0;
        number_of_sat_blocks = 0;
        psat_blocks = cur_block_address;
        while (end_sat_blocks) {
          while (j < (*im)->blockSize) {
            totalBlocks = j + 1;
            *(byte *)puStack_64 = psat_blocks[j * 2 + 1];
            *sat_block_high = psat_blocks[totalBlocks * 2 + 1];
            if (((cur_sat_block == 0) ||
                ((*PTR_INTERNAL_METADATA_06026dd4)->totalBlocks < used_block)) ||
               ((*PTR_INTERNAL_METADATA_06026dd4)->totalBlocks < ((int)cur_sat_block & 0xffffU))) {
              end_sat_blocks = false;
              totalBlocks = (*im)->blockSize;
            }
            else {
              used_block = used_block + 1;
              im2 = *im;
              *(byte **)(im2->sat_blocks + number_of_sat_blocks_in_sat_list * 2) =
                   im2->backup_ram_start + im2->blockSize_in_bytes * ((int)cur_sat_block & 0xffffU);
              number_of_sat_blocks_in_sat_list = number_of_sat_blocks_in_sat_list + 1;
            }
            j = totalBlocks + 1;
          }
          j = 4;
          psat_blocks = *(byte **)((*im)->sat_blocks + number_of_sat_blocks * 2);
          number_of_sat_blocks = number_of_sat_blocks + 1;
        }
      }
      cur_block_address = cur_block_address + (*im)->blockSize_in_bytes;
    }
    totalBlocks = (cart_remaining_blocks - used_block) - reserved_blocks;
    output_stat->freeblock = totalBlocks;
    if (totalBlocks == 0) {
      output_stat->freesize = 0;
    }
    else {
      output_stat->freesize = output_stat->freeblock * ((*im)->blockSize - 6) - 0x1e;
    }
                    /* What are these divisions? */
    (*(code *)(PTR_LAB_06026e8c + 0x6026de8))();
    totalBlocks = (*(code *)(DWORD_06026e90 + 0x6026df0))();
    output_stat->datanum = totalBlocks;
    return BUP_SUCCESS;
  }
                    /* Serial code start */
  if ((*PTR_INTERNAL_METADATA_06026b14)->serial_connected == 0) {
    return BUP_NOT_CONNECTED;
  }
  result = (*(code *)(DAT_06026b18 + 0x6026ad8))
                     (auStack_38,
                      (int)(char)(*PTR_INTERNAL_METADATA_06026b14)->serial_partition_number);
  if (result != 0) {
    if (result == 0x23) {
      return BUP_WRITE_PROTECTED;
    }
    if (result != 0x24) {
      if ((result != DAT_06026b82) && (result != DAT_06026b84)) {
        return ~BUP_SUCCESS;
      }
      return BUP_NOT_CONNECTED;
    }
    return BUP_NOT_FORMATTED;
  }
  output_stat->totalsize = dStack_34;
  output_stat->totalblock = dStack_30;
  output_stat->blocksize = (int)sStack_2c & 0xffff;
  datanum = uStack_4c;
  result = (*(code *)(DAT_06026b1c + 0x6026b00))
                     (&output_stat->freesize,&output_stat->freeblock,&datanum);
  if (result == 0) {
    output_stat->datanum = datanum;
    return BUP_SUCCESS;
  }
  if (result == 0x21) {
    return BUP_NOT_CONNECTED;
  }
  if (result == 0x23) {
    return BUP_WRITE_PROTECTED;
  }
  if (result != 0x24) {
    return ~BUP_SUCCESS;
  }
  return BUP_NOT_FORMATTED;
}


void Init(INTERNAL_METADATA *im_out,backup_config *config)

{
  byte cart_type_flag;
  int iVar1;
  dword totalblocks_cart;
  dword blocksize_cart;
  undefined *CARTRIDGE_MEMORY_END_2;
  INTERNAL_METADATA **im;
  
  im = PTR_INTERNAL_METADATA_0602653c;
  *PTR_INTERNAL_METADATA_0602653c = im_out;
  im_out->function_pointers[0] = PTR_Onchip_BCR1_06026540 + 0x6026440;
  im_out->function_pointers[1] = (undefined *)(DAT_06026544 + 0x6026448);
  im_out->function_pointers[2] = (undefined *)(DAT_06026548 + 0x6026450);
  im_out->function_pointers[3] = (undefined *)(DAT_0602654c + 0x6026458);
  im_out->function_pointers[4] = (undefined *)(DAT_06026550 + 0x6026460);
  im_out->function_pointers[5] = PTR_LAB_06026554 + 0x6026468;
  im_out->function_pointers[6] = PTR_LAB_06026558 + 0x6026470;
  im_out->function_pointers[7] = PTR_PTR_0602655c + 0x6026478;
  im_out->function_pointers[8] = PTR_LAB_06026560 + 0x6026480;
  im_out->function_pointers[9] = PTR_PTR_DAT_06026564 + 0x6026488;
  im_out->function_pointers[10] = (undefined *)(DAT_06026568 + 0x6026490);
  (*im)->sat_blocks = (short *)(*im + 1);
  config->unit_id = 1;
  config->partition = 1;
  (*im)->internal_connected = 1;
  CARTRIDGE_MEMORY_END_2 = CARTRIDGE_MEMORY_END;
  totalblocks_cart = (dword)totalblocks_cart_0x400;
  blocksize_cart = (dword)blocksize_cart_0x200;
  if (((int)(char)*CARTRIDGE_MEMORY_END & 0xe0U) == 0) {
    if ((*CARTRIDGE_MEMORY_END & 0x18) == 0) {
      config[1].unit_id = 0;
      config[1].partition = 1;
      (*im)->cartridge_connected = 0;
      if ((*CARTRIDGE_MEMORY_END_2 & 7) == 1) {
        (*im)->cartridge_offset_to_data_in_blocks = 2;
        (*im)->cartridge_flag_2 = 1;
        (*(code *)(DAT_06026668 + 0x60265e4))();
        if (*PTR_DAT_0602666c == '\x1f') {
          if (((int)(char)*PTR_DAT_06026670 & 0xffU) == 0x5b) {
            config[1].unit_id = 2;
            (*im)->cartridge_connected = 1;
            (*im)->totalBlocks_cart = totalblocks_cart;
            (*im)->blockSize_cart = blocksize_cart;
          }
          else if (((int)(char)*PTR_DAT_06026670 & 0xffU) == (int)PTR_DAT_06026664._0_2_) {
            config[1].unit_id = 2;
            (*im)->cartridge_connected = 1;
            (*im)->totalBlocks_cart = (int)totalblocks_cart_0x800;
            (*im)->blockSize_cart = (int)blocksize_cart_0x100;
          }
        }
        (*(code *)(DAT_06026674 + 0x6026644))();
      }
    }
  }
  else {
                    /* Check for cartridge */
    if (((int)(char)*CARTRIDGE_MEMORY_END & 0xe0U) == 0x20) {
      config[1].unit_id = 2;
      config[1].partition = 1;
      (*im)->cartridge_connected = 1;
      (*im)->cartridge_offset_to_data_in_blocks = 2;
      (*im)->cartridge_flag_2 = 0;
      cart_type_flag = *CARTRIDGE_MEMORY_END_2 & 7;
      if (cart_type_flag == 0) {
        (*im)->totalBlocks_cart = totalblocks_cart;
        (*im)->blockSize_cart = blocksize_cart;
      }
      else if (cart_type_flag == 1) {
        (*im)->totalBlocks_cart = totalblocks_cart;
        (*im)->blockSize_cart = blocksize_cart;
      }
      else if (cart_type_flag == 2) {
        (*im)->totalBlocks_cart = (int)totalblock_cart_0x800;
        (*im)->blockSize_cart = blocksize_cart;
      }
      else if (cart_type_flag == 3) {
        (*im)->totalBlocks_cart = (int)totalblocks_cart_0x1000;
        (*im)->blockSize_cart = blocksize_cart;
      }
      else if (cart_type_flag == 4) {
        (*im)->totalBlocks_cart = (int)totalblocks_cart_0x1000;
        (*im)->blockSize_cart = totalblocks_cart;
      }
      else {
        config[1].unit_id = 0;
        config[1].partition = 0;
        (*im)->cartridge_connected = 0;
      }
    }
    else {
      config[1].unit_id = 0;
      config[1].partition = 0;
      (*im)->cartridge_connected = 0;
    }
  }
                    /* Check for serial connection */
  iVar1 = (*(code *)(DAT_06026734 + 0x6026690))(config + 2);
  if (iVar1 == 0) {
    if (config[2].unit_id < 0x10) {
      (*im)->serial_connected = 1;
    }
    else {
      config[2].unit_id = 0;
      config[2].partition = 0;
    }
  }
  else {
    (*im)->serial_connected = 0;
    config[2].unit_id = 0;
    config[2].partition = 0;
  }
  return;
}


undefined4 WaitLoop__(void)

{
  dword counter;
  
  counter = 47000_iterations;
  do {
    counter = counter - 1_DEC;
  } while (counter != 0);
  return 0;
}


int Serial_ProcessError_(int serial_error)

{
  SERIAL_STRUCT SStack_20;
  INTERNAL_METADATA **im;
  
  im = PTR_INTERNAL_METADATA_06028578;
  if (serial_error == (short)SERIAL_ERROR_0x101) {
    (**(code **)PTR_PTR_SetOnChipReg__060285f4)
              ((*PTR_INTERNAL_METADATA_06028578)->serial_int_mask__);
SOMETHING_ONCHIP__:
    *(undefined *)(int)DAT_060285e8 = 0;
    return serial_error;
  }
  if (serial_error != (short)SERIAL_ERROR_0x103) {
    if (serial_error == (short)SERIAL_ERROR_0x104) {
      *(byte *)(int)DAT_060285e6 = *(byte *)(int)DAT_060285e6 & 0xef;
    }
    else if (serial_error != (short)SERIAL_ERROR_0x104) {
      if (serial_error == (short)SERIAL_ERROR_0x106) goto SOMETHING_ONCHIP__;
      goto RETURN_ERROR_CODE;
    }
  }
  (**(code **)PTR_PTR_SetOnChipReg__060285f4)((*im)->serial_int_mask__);
  *(undefined *)(int)DAT_060285e8 = 0;
RETURN_ERROR_CODE:
  Serial_SetPartition(&SStack_20,(*im)->serial_partition_number);
  return serial_error;
}


/* WARNING: Could not reconcile some variable overlaps */

BUP_ERROR BUP_Write(BACKUP_DEVICE device,backup_file *file,uchar *data,
                   BACKUP_OVERWRITE_MODE overwrite_mode)

{
  BUP_ERROR BVar1;
  short sVar3;
  uint blocks_needed;
  BUP_ERROR BVar2;
  int iVar4;
  INTERNAL_METADATA *im2;
  byte *backup_ram_start;
  uint read_offset;
  uint comment_offset;
  byte *data_to_write;
  dword *pdVar5;
  short *sat_blocks;
  int block_offset;
  undefined4 block_tag;
  uint block_index;
  uint i;
  uint uStack_74;
  char first_block_flag;
  undefined4 uStack_64;
  backup_file bStack_60;
  backup_stat device_stat;
  INTERNAL_METADATA **im;
  int write_offset;
  
  im = PTR_INTERNAL_METADATA_06026f10;
  if (device == DEVICE_SERIAL) {
    if ((*PTR_INTERNAL_METADATA_06026f10)->serial_connected == 0) {
      BVar1 = BUP_NOT_CONNECTED;
    }
    else if ((overwrite_mode == OVERWRITE_OFF) ||
            (BVar1 = BUP_Dir(DEVICE_SERIAL,file->filename,1,&bStack_60), BVar1 == BUP_SUCCESS)) {
      block_offset = (*(code *)(PTR_LAB_06026f14 + 0x6026ef2))(file,data);
      if (block_offset == 0) {
        BVar1 = BUP_SUCCESS;
      }
      else if (block_offset == 0x21) {
        BVar1 = BUP_NOT_CONNECTED;
      }
      else if (block_offset == 0x23) {
        BVar1 = BUP_WRITE_PROTECTED;
      }
      else if (block_offset == 0x24) {
        BVar1 = BUP_NOT_FORMATTED;
      }
      else if (block_offset == 0x31) {
        BVar1 = BUP_NOT_ENOUGH_SPACE;
      }
      else if ((block_offset == DAT_06026f92) || (block_offset == DAT_06026f94)) {
        BVar1 = BUP_NOT_CONNECTED;
      }
      else {
        BVar1 = ~BUP_SUCCESS;
      }
    }
    else {
      BVar1 = BUP_FOUND;
    }
  }
  else {
    BVar1 = BUP_Stat(device,0,&device_stat);
    if (BVar1 == BUP_SUCCESS) {
                    /* Check if file exists */
      sVar3 = SearchForSaveBlock((char *)file,DEFAULT);
      if (sVar3 != 0) {
        if (overwrite_mode != OVERWRITE_OFF) {
          return BUP_FOUND;
        }
        DeleteFileByID();
        BVar1 = BUP_Stat(device,0,&device_stat);
        if (BVar1 != BUP_SUCCESS) {
          return BVar1;
        }
      }
                    /* software divide = (bytes + 29)/58 */
      block_offset = (*(code *)(PTR_DAT_06027020 + 0x6026fa4))();
      blocks_needed = block_offset + 1;
      if (device_stat.freeblock < blocks_needed) {
        BVar1 = BUP_NOT_ENOUGH_SPACE;
      }
      else {
        find_free_blocks__(blocks_needed);
        sVar3 = *(*im)->sat_blocks;
        if ((*im)->cart_format_flag_ == 1) {
          uStack_64 = *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_06027024;
          (**(code **)PTR_PTR_SetOnChipReg__06027028)(0xffffffff);
        }
        first_block_flag = '\0';
        block_index = 1;
        uStack_74 = 0;
        for (i = 0; i < blocks_needed; i = i + 1) {
          read_offset = 0;
          im2 = *im;
          block_offset = ((int)im2->sat_blocks[i] & 0xffffU) * im2->blockSize_in_bytes;
          backup_ram_start = im2->backup_ram_start;
          if (first_block_flag == 0) {
            first_block_flag = 1;
            block_tag = CONCAT31(CONCAT21(CONCAT11(backup_ram_start[block_offset + 1],
                                                   backup_ram_start[block_offset + 3]),
                                          backup_ram_start[block_offset + 5]),
                                 backup_ram_start[block_offset + 7]);
            if ((*im)->cart_format_flag_ != 0) {
                    /* why does the cart flag influence the block tag?? */
              block_tag = block_tag + 1;
            }
            backup_ram_start[block_offset + 1] = block_tag._0_1_ | 0x80;
            backup_ram_start[block_offset + 3] = block_tag._1_1_;
            backup_ram_start[block_offset + 5] = block_tag._2_1_;
            backup_ram_start[block_offset + 7] = (byte)block_tag;
            read_offset = 0;
            write_offset = 8;
            do {
              iVar4 = write_offset;
                    /* write the filename
                        */
              data_to_write = file->filename + read_offset;
              read_offset = read_offset + 1;
              backup_ram_start[iVar4 + 1 + block_offset] = *data_to_write;
              write_offset = iVar4 + 2;
            } while (read_offset < 0xb);
                    /* write the language byte
                        */
            read_offset = iVar4 + 4;
            backup_ram_start[iVar4 + 3 + block_offset] = file->language;
            comment_offset = 0;
            do {
                    /* write the comment */
              backup_ram_start[read_offset + 1 + block_offset] = file->comment[comment_offset];
              write_offset = comment_offset + 1;
              comment_offset = comment_offset + 2;
              backup_ram_start[read_offset + 3 + block_offset] = file->comment[write_offset];
              read_offset = read_offset + 4;
            } while (comment_offset < 10);
            pdVar5 = &file->date;
            do {
                    /* write the date */
              data_to_write = (byte *)((int)pdVar5 + 1);
              backup_ram_start[read_offset + 1 + block_offset] = *(byte *)pdVar5;
              pdVar5 = (dword *)((int)pdVar5 + 2);
              backup_ram_start[read_offset + 3 + block_offset] = *data_to_write;
              read_offset = read_offset + 4;
            } while (pdVar5 < &file->datasize);
            pdVar5 = &file->datasize;
            do {
              data_to_write = (byte *)((int)pdVar5 + 1);
              backup_ram_start[read_offset + 1 + block_offset] = *(byte *)pdVar5;
              pdVar5 = (dword *)((int)pdVar5 + 2);
              backup_ram_start[read_offset + 3 + block_offset] = *data_to_write;
              read_offset = read_offset + 4;
            } while (pdVar5 < &file->blocksize);
NEXT_DATA_BLOCK:
            if (read_offset == 0) {
                    /* if at beginning of block, add another tag */
              block_tag = CONCAT31(CONCAT21(CONCAT11(backup_ram_start[block_offset + 1],
                                                     backup_ram_start[block_offset + 3]),
                                            backup_ram_start[block_offset + 5]),
                                   backup_ram_start[block_offset + 7]);
              if ((*im)->cart_format_flag_ != 0) {
                block_tag = block_tag + 1;
              }
              backup_ram_start[block_offset + 1] = block_tag._0_1_;
              backup_ram_start[block_offset + 3] = block_tag._1_1_;
              backup_ram_start[block_offset + 5] = block_tag._2_1_;
              backup_ram_start[block_offset + 7] = (byte)block_tag;
              read_offset = 8;
            }
                    /* write the list of sat_blocks? */
            while ((read_offset < (*im)->blockSize_in_bytes && (block_index <= blocks_needed))) {
              sat_blocks = (*im)->sat_blocks;
              backup_ram_start[read_offset + 1 + block_offset] = *(byte *)(sat_blocks + block_index)
              ;
              write_offset = read_offset + 3;
              read_offset = read_offset + 4;
              backup_ram_start[write_offset + block_offset] =
                   *(byte *)((int)(sat_blocks + block_index) + 1);
              block_index = block_index + 1;
            }
            if (read_offset != (*im)->blockSize_in_bytes) {
              first_block_flag = 0x2;
LAB_060271ba:
              if (read_offset == 0) {
                block_tag = CONCAT31(CONCAT21(CONCAT11(backup_ram_start[block_offset + 1],
                                                       backup_ram_start[block_offset + 3]),
                                              backup_ram_start[block_offset + 5]),
                                     backup_ram_start[block_offset + 7]);
                if ((*im)->cart_format_flag_ != 0) {
                  block_tag = block_tag + 1;
                }
                backup_ram_start[block_offset + 1] = block_tag._0_1_;
                backup_ram_start[block_offset + 3] = block_tag._1_1_;
                backup_ram_start[block_offset + 5] = block_tag._2_1_;
                backup_ram_start[block_offset + 7] = (byte)block_tag;
                read_offset = 8;
              }
              while (read_offset < (*im)->blockSize_in_bytes) {
                write_offset = read_offset + 1;
                if (uStack_74 < file->datasize) {
                  backup_ram_start[write_offset + block_offset] = data[uStack_74];
                  read_offset = read_offset + 2;
                  uStack_74 = uStack_74 + 1;
                }
                else {
                  read_offset = read_offset + 2;
                  backup_ram_start[write_offset + block_offset] = 0;
                }
              }
            }
          }
          else {
            if (first_block_flag == 0x1) goto NEXT_DATA_BLOCK;
            if (first_block_flag == 0x2) goto LAB_060271ba;
          }
          if ((*im)->cart_format_flag_ == 1) {
            (*(code *)(PTR_LAB_060272d4 + 0x6027262))();
          }
        }
        if ((*im)->cart_format_flag_ == 1) {
          (**(code **)PTR_PTR_SetOnChipReg__060272d8)(uStack_64);
        }
        BVar1 = ChecksumData(sVar3,data);
        if (*(int *)&(*im)->bad_block != 0) {
          BVar2 = mark_bad_blocks___(*(uint *)&(*im)->bad_block & 0xffff);
          if (BVar2 != BUP_SUCCESS) {
            BVar1 = BVar2;
          }
          if (sVar3 != 0) {
            DeleteFileByID((int)sVar3);
          }
        }
      }
    }
  }
                    /* File exists and we did not specify overwrite mode */
  return BVar1;
}


BUP_ERROR BUP_Read(BACKUP_DEVICE device,uchar *filename,uchar *output_data)

{
  int iVar1;
  BUP_ERROR BVar2;
  word block_index;
  backup_stat bStack_1c;
  
  if (device != DEVICE_SERIAL) {
    BVar2 = BUP_Stat(device,0,&bStack_1c);
    if (BVar2 != BUP_SUCCESS) {
      return BVar2;
    }
    block_index = SearchForSaveBlock((char *)filename,DEFAULT);
    if (block_index != 0) {
      BVar2 = ReadByBlockId(block_index,output_data);
      return BVar2;
    }
    return BUP_NOT_FOUND;
  }
  if ((*PTR_INTERNAL_METADATA_060277b4)->serial_connected == 0) {
    return BUP_NOT_CONNECTED;
  }
  iVar1 = (*(code *)(PTR_PTR_060277b8 + 0x60277a8))(filename,output_data,0);
  if (iVar1 == 0) {
    return BUP_SUCCESS;
  }
  if (iVar1 == 0x21) {
    return BUP_NOT_CONNECTED;
  }
  if (iVar1 == 0x23) {
    return BUP_WRITE_PROTECTED;
  }
  if (iVar1 == 0x24) {
    return BUP_NOT_FORMATTED;
  }
  if (iVar1 != 0x30) {
    if ((iVar1 != DAT_06027846) && (iVar1 != DAT_06027848)) {
      return ~BUP_SUCCESS;
    }
    return BUP_NOT_CONNECTED;
  }
  return BUP_NOT_FOUND;
}


/* WARNING: Could not reconcile some variable overlaps */

undefined4 serial_write2(int param_1,int param_2,undefined param_3)

{
  undefined *puVar1;
  undefined4 uVar2;
  int iVar3;
  undefined *puVar4;
  uint uVar5;
  short sVar6;
  undefined *puVar7;
  int iVar8;
  uint uVar9;
  byte *pbVar10;
  undefined4 local_2c;
  undefined *puStack_28;
  undefined4 uStack_24;
  
  puVar1 = PTR_DAT_060295c0;
  puVar7 = (undefined *)(int)DAT_060295b4;
  iVar8 = (int)DAT_060295b6;
  uVar9 = (uint)DAT_060295b8;
  pbVar10 = (byte *)(int)DAT_060295ba;
  *(byte *)(int)DAT_060295bc = pbVar10[-2] & 0xc | 0x20;
  local_2c._3_1_ = SUB41(PTR_DAT_060295c4,0);
  local_2c._2_2_ = CONCAT11(param_3,(undefined)local_2c);
  local_2c = (uint)PTR_DAT_060295c4 & 0xffff0000 | (uint)local_2c._2_2_;
  puStack_28 = (undefined *)((int)&local_2c + 1);
  for (puVar4 = puStack_28; uStack_24 = param_2, puVar4 < (undefined *)((int)&local_2c + 3);
      puVar4 = puVar4 + 1) {
    sVar6 = 0;
    while (((int)(char)*pbVar10 & 0xffU & uVar9) == 0) {
      sVar6 = sVar6 + 1;
      if (sVar6 < 0) {
        uVar2 = Serial_ProcessError_(iVar8);
        return uVar2;
      }
    }
    *puVar7 = *puVar4;
    *pbVar10 = *pbVar10 & 0x7f;
  }
  local_2c = local_2c ^ (uint)PTR_DAT_060295c8;
  for (uVar5 = 0; uVar5 < param_2 + 4U; uVar5 = uVar5 + 1) {
    sVar6 = 0;
    while (((int)(char)*pbVar10 & 0xffU & uVar9) == 0) {
      sVar6 = sVar6 + 1;
      if (sVar6 < 0) {
        uVar2 = (*(code *)(DAT_060295cc + 0x6029592))(iVar8);
        return uVar2;
      }
    }
    if (uVar5 < 2) {
      local_2c = local_2c & 0xffffff00 | (uint)*(byte *)((int)&uStack_24 + uVar5 + 2);
    }
    else if (uVar5 < param_2 + 2U) {
      local_2c = local_2c & 0xffffff00 | (uint)*(byte *)(param_1 + uVar5 + -2);
    }
    else {
      local_2c = local_2c & 0xffffff00;
    }
    *puVar7 = (undefined)local_2c;
    *pbVar10 = *pbVar10 & 0x7f;
    local_2c = local_2c << 4;
    local_2c._0_1_ = (char)(local_2c >> 0x18);
    if (local_2c._0_1_ != '\0') {
      local_2c = local_2c ^ ((int)local_2c._0_1_ & 0xffU) * (int)puVar1;
    }
    local_2c = local_2c << 4;
    local_2c._0_1_ = (char)(local_2c >> 0x18);
    if (local_2c._0_1_ != '\0') {
      local_2c = local_2c ^ ((int)local_2c._0_1_ & 0xffU) * (int)puVar1;
    }
  }
  for (iVar3 = 4; puVar4 = puStack_28, iVar3 != 0; iVar3 = iVar3 + -1) {
    local_2c = local_2c << 4;
    local_2c._0_1_ = (char)(local_2c >> 0x18);
    if (local_2c._0_1_ != '\0') {
      local_2c = local_2c ^ ((int)local_2c._0_1_ & 0xffU) * (int)puVar1;
    }
  }
  do {
    if ((undefined *)((int)&local_2c + 3) <= puVar4) {
      do {
      } while ((*pbVar10 & 4) == 0);
      *(byte *)(int)DAT_06029724 = *(byte *)(int)DAT_06029724 & 0xf;
      return 0;
    }
    sVar6 = 0;
    while (((int)(char)*pbVar10 & 0xffU & uVar9) == 0) {
      sVar6 = sVar6 + 1;
      if (sVar6 < 0) {
        uVar2 = (*(code *)(DAT_0602967c + 0x6029678))(iVar8);
        return uVar2;
      }
    }
    *puVar7 = *puVar4;
    *pbVar10 = *pbVar10 & 0x7f;
    puVar4 = puVar4 + 1;
  } while( true );
}


/* WARNING: Could not reconcile some variable overlaps */

undefined4 serial_read_data___(undefined *buf,uint size__,uint param_3)

{
  undefined *puVar1;
  undefined4 uVar2;
  uint cur;
  uint uVar3;
  uint uVar4;
  uint end;
  undefined *puVar5;
  byte *pbVar6;
  undefined4 local_3c;
  undefined *puStack_38;
  uint uStack_34;
  undefined *puStack_30;
  undefined *puStack_2c;
  undefined4 *puStack_28;
  
  puVar1 = PTR_DAT_0602877c;
  puStack_28 = &local_3c;
  puVar5 = (undefined *)(int)DAT_06028770;
  pbVar6 = puVar5 + -1;
  (*PTR_INTERNAL_METADATA_06028780)->serial_int_mask__ = *(dword *)PTR_PTR_TO_0xFFFFF17C_06028784;
  puStack_38 = (undefined *)param_3;
  uStack_34 = size__;
  (**(code **)PTR_PTR_SetOnChipReg__06028788)(0xffffffff);
  *(byte *)(int)DAT_06028772 = *(byte *)(int)DAT_06028772 & 0xc | 0x12;
  *pbVar6 = *pbVar6 & 0xbf;
  cur = 0;
  end = uStack_34 + 2;
  puStack_2c = (undefined *)((int)&local_3c + 1);
  puStack_30 = (undefined *)((int)&local_3c + 2);
  uVar4 = (uint)puStack_38;
  puStack_38 = (undefined *)((int)&local_3c + 3);
  do {
    if (end <= cur) {
      *(byte *)(int)DAT_060288fe = *(byte *)(int)DAT_060288fe & 0xf;
      *pbVar6 = 0;
      (**(code **)PTR_PTR_SetOnChipReg__06028904)
                (*(undefined4 *)(*(int *)PTR_INTERNAL_METADATA_06028908 + 0x6c));
      local_3c = local_3c << 4;
      if (*(short *)puStack_28 == 0) {
        uVar2 = 0;
      }
      else {
        uVar2 = Serial_ProcessError_((int)PTR_DAT_06028900._0_2_);
      }
      return uVar2;
    }
    uVar3 = 0;
    do {
      uVar3 = uVar3 + 1;
      if (uVar4 < uVar3) {
        uVar2 = Serial_ProcessError_((int)DAT_06028774);
        return uVar2;
      }
      if ((*pbVar6 & 8) != 0) {
        uVar2 = Serial_ProcessError_((int)DAT_06028776);
        return uVar2;
      }
      if ((*pbVar6 & 0x10) != 0) {
        uVar2 = Serial_ProcessError_((int)PTR_DAT_06028778._0_2_);
        return uVar2;
      }
      if ((*pbVar6 & 0x20) != 0) {
        uVar2 = Serial_ProcessError_((int)DAT_0602883a);
        return uVar2;
      }
    } while ((*pbVar6 & 0x40) == 0);
    uVar4 = (uint)DAT_0602883c;
    if (cur == 0) {
      *buf = *puVar5;
      local_3c = 0;
      *puStack_2c = *buf;
    }
    else if (cur == 1) {
      buf[1] = *puVar5;
      *puStack_30 = buf[1];
      local_3c = local_3c ^ (uint)PTR_DAT_06028840;
    }
    else {
      *puStack_38 = *puVar5;
      if (cur < uStack_34) {
        buf[cur] = *puStack_38;
      }
      local_3c = local_3c << 4;
      local_3c._0_1_ = (char)(local_3c >> 0x18);
      if (local_3c._0_1_ != '\0') {
        local_3c = local_3c ^ ((int)local_3c._0_1_ & 0xffU) * (int)puVar1;
      }
      local_3c = local_3c << 4;
      local_3c._0_1_ = (char)(local_3c >> 0x18);
      if (local_3c._0_1_ != '\0') {
        local_3c = local_3c ^ ((int)local_3c._0_1_ & 0xffU) * (int)puVar1;
      }
    }
    *pbVar6 = *pbVar6 & 0xbf;
    cur = cur + 1;
  } while( true );
}


/* WARNING: Could not reconcile some variable overlaps */
/* WARNING: Restarted to delay deadcode elimination for space: stack */

int serial_send_data_chksum___(byte *buf,uint size)

{
  bool bVar1;
  bool bVar2;
  int iVar3;
  uint uVar4;
  undefined4 chksum__;
  byte local_22 [6];
  
  iVar3 = 0;
  bVar2 = false;
  bVar1 = true;
  chksum__ = (uint)*buf << 0x10;
  uVar4 = 3;
  chksum__ = CONCAT31((uint3)(chksum__ >> 8) | (uint3)buf[1],buf[2]);
  chksum__ = chksum__ ^ (uint)PTR_DAT_06029948;
  while (bVar1) {
    chksum__ = chksum__ << 4;
    chksum__._0_1_ = (char)(chksum__ >> 0x18);
    if (chksum__._0_1_ != '\0') {
      chksum__ = chksum__ ^ ((int)chksum__._0_1_ & 0xffU) * (int)PTR_DAT_06029944;
    }
    if (bVar2) {
      if (uVar4 < size) {
        chksum__ = chksum__ & 0xffffff00 | (uint)buf[uVar4];
        uVar4 = uVar4 + 1;
      }
      else if ((iVar3 == 0) || (iVar3 == 1)) {
        chksum__ = chksum__ & 0xffffff00 | (uint)local_22[iVar3];
        iVar3 = iVar3 + 1;
      }
      else {
        bVar1 = false;
      }
    }
    bVar2 = (bool)(bVar2 ^ 1);
  }
  return (int)chksum__._1_2_;
}


int serial_format(char param_1)

{
  int iVar1;
  byte local_c [4];
  char cStack_8;
  
  cStack_8 = param_1;
  iVar1 = serial_send_cmd__(0x20,(int)param_1 & 0xff,local_c);
  if (((int)(char)local_c[0] & 0xffU) == (int)(short)SERIAL_ERROR_0xff) {
    return (int)(short)SERIAL_ERROR_0x107;
  }
  if (iVar1 != 0) {
    return iVar1;
  }
  iVar1 = Serial_Read_error__(local_c);
  if (iVar1 != 0) {
    return iVar1;
  }
  if (((int)(char)local_c[0] & 0xffU) == (int)DAT_06028bee) {
    return 0;
  }
  return (int)DAT_06028bf0;
}


longlong software_modulo_(void)

{
  char cVar1;
  bool bVar2;
  bool bVar3;
  bool bVar4;
  byte bVar5;
  uint uVar6;
  undefined *puVar7;
  int in_r0;
  uint in_r1;
  uint uVar8;
  uint uVar10;
  uint uVar12;
  uint uVar13;
  uint uVar14;
  uint uVar15;
  uint uVar16;
  uint uVar17;
  uint uVar18;
  uint uVar19;
  uint uVar20;
  uint uVar21;
  uint uVar22;
  uint uVar23;
  uint uVar24;
  uint uVar25;
  uint uVar26;
  uint uVar27;
  uint uVar28;
  uint uVar29;
  uint uVar30;
  uint uVar31;
  uint uVar32;
  uint uVar33;
  uint uVar34;
  uint uVar35;
  uint uVar36;
  uint uVar37;
  uint uVar38;
  uint uVar39;
  uint uVar40;
  uint uVar41;
  uint uVar9;
  uint uVar11;
  
  puVar7 = PTR_DAT_06029c50;
  if (in_r0 == 0) {
    *(undefined4 *)PTR_DAT_06029c50 = DAT_06029c54;
    return ZEXT48(puVar7) << 0x20;
  }
  uVar8 = (uint)((in_r1 & 0x80000000) != 0);
  uVar9 = uVar8 - in_r0;
  bVar4 = uVar9 <= uVar8;
  uVar13 = in_r1 << 2;
  bVar3 = (uVar9 & 0x80000000) == 0;
  uVar8 = uVar9 * 2 | (uint)((in_r1 & 0x40000000) != 0);
  uVar9 = (uint)bVar4 * (uVar8 - in_r0) + (uint)!bVar4 * (uVar8 + in_r0);
  cVar1 = bVar4 * (uVar8 < uVar9) + !bVar4 * (uVar9 < uVar8);
  bVar5 = bVar3 * cVar1 + (!bVar3 && cVar1 == '\0');
  uVar8 = (uint)bVar5 << 8;
  uVar10 = uVar9 * 2 | (uint)((uVar13 & 0x80000000) != 0);
  bVar3 = (bVar5 & 1) == ((byte)(uVar8 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar8 >> 9) & 1) == ((uVar9 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar10 - in_r0) + (uint)!bVar3 * (uVar10 + in_r0);
  cVar1 = bVar3 * (uVar10 < uVar11) + !bVar3 * (uVar11 < uVar10);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar14 = uVar8 & 0xfffffeff | uVar9;
  uVar6 = uVar8 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x40000000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar15 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x20000000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar16 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x10000000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar17 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x8000000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar18 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x4000000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar19 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x2000000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar20 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x1000000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar21 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x800000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar22 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x400000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar23 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x200000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar24 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x100000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar25 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x80000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar26 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x40000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar27 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x20000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar28 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x10000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar29 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x8000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar30 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x4000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar31 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x2000) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar32 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x1000) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar33 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x800) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar34 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x400) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar35 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x200) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar36 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x100) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar37 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x80) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar38 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x40) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar39 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x20) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar40 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 0x10) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar10 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar41 = uVar6 | uVar9 & 0xfffffeff | uVar10;
  uVar6 = uVar6 | uVar9 & 0xfffffefe;
  uVar9 = uVar6 | uVar10;
  uVar12 = uVar11 * 2 | (uint)((uVar13 & 8) != 0);
  bVar3 = ((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar9 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar11 = (uint)bVar3 * (uVar12 - in_r0) + (uint)!bVar3 * (uVar12 + in_r0);
  cVar1 = bVar3 * (uVar12 < uVar11) + !bVar3 * (uVar11 < uVar12);
  uVar9 = (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  uVar12 = uVar6 | uVar10 & 0xfffffeff | uVar9;
  uVar6 = uVar6 | uVar10 & 0xfffffefe;
  uVar10 = uVar6 | uVar9;
  uVar8 = ((((((((((((((((((((((((((((((uint)bVar4 << 1 |
                                      (uint)((bVar5 & 1) == ((byte)(uVar8 >> 9) & 1))) << 1 |
                                     (uint)(((byte)(uVar14 >> 8) & 1) == ((byte)(uVar14 >> 9) & 1)))
                                     << 1 | (uint)(((byte)(uVar15 >> 8) & 1) ==
                                                  ((byte)(uVar15 >> 9) & 1))) << 1 |
                                   (uint)(((byte)(uVar16 >> 8) & 1) == ((byte)(uVar16 >> 9) & 1)))
                                   << 1 | (uint)(((byte)(uVar17 >> 8) & 1) ==
                                                ((byte)(uVar17 >> 9) & 1))) << 1 |
                                 (uint)(((byte)(uVar18 >> 8) & 1) == ((byte)(uVar18 >> 9) & 1))) <<
                                 1 | (uint)(((byte)(uVar19 >> 8) & 1) == ((byte)(uVar19 >> 9) & 1)))
                                << 1 | (uint)(((byte)(uVar20 >> 8) & 1) == ((byte)(uVar20 >> 9) & 1)
                                             )) << 1 |
                              (uint)(((byte)(uVar21 >> 8) & 1) == ((byte)(uVar21 >> 9) & 1))) << 1 |
                             (uint)(((byte)(uVar22 >> 8) & 1) == ((byte)(uVar22 >> 9) & 1))) << 1 |
                            (uint)(((byte)(uVar23 >> 8) & 1) == ((byte)(uVar23 >> 9) & 1))) << 1 |
                           (uint)(((byte)(uVar24 >> 8) & 1) == ((byte)(uVar24 >> 9) & 1))) << 1 |
                          (uint)(((byte)(uVar25 >> 8) & 1) == ((byte)(uVar25 >> 9) & 1))) << 1 |
                         (uint)(((byte)(uVar26 >> 8) & 1) == ((byte)(uVar26 >> 9) & 1))) << 1 |
                        (uint)(((byte)(uVar27 >> 8) & 1) == ((byte)(uVar27 >> 9) & 1))) << 1 |
                       (uint)(((byte)(uVar28 >> 8) & 1) == ((byte)(uVar28 >> 9) & 1))) << 1 |
                      (uint)(((byte)(uVar29 >> 8) & 1) == ((byte)(uVar29 >> 9) & 1))) << 1 |
                     (uint)(((byte)(uVar30 >> 8) & 1) == ((byte)(uVar30 >> 9) & 1))) << 1 |
                    (uint)(((byte)(uVar31 >> 8) & 1) == ((byte)(uVar31 >> 9) & 1))) << 1 |
                   (uint)(((byte)(uVar32 >> 8) & 1) == ((byte)(uVar32 >> 9) & 1))) << 1 |
                  (uint)(((byte)(uVar33 >> 8) & 1) == ((byte)(uVar33 >> 9) & 1))) << 1 |
                 (uint)(((byte)(uVar34 >> 8) & 1) == ((byte)(uVar34 >> 9) & 1))) << 1 |
                (uint)(((byte)(uVar35 >> 8) & 1) == ((byte)(uVar35 >> 9) & 1))) << 1 |
               (uint)(((byte)(uVar36 >> 8) & 1) == ((byte)(uVar36 >> 9) & 1))) << 1 |
              (uint)(((byte)(uVar37 >> 8) & 1) == ((byte)(uVar37 >> 9) & 1))) << 1 |
             (uint)(((byte)(uVar38 >> 8) & 1) == ((byte)(uVar38 >> 9) & 1))) << 1 |
            (uint)(((byte)(uVar39 >> 8) & 1) == ((byte)(uVar39 >> 9) & 1))) << 1 |
           (uint)(((byte)(uVar40 >> 8) & 1) == ((byte)(uVar40 >> 9) & 1))) << 1 |
          (uint)(((byte)(uVar41 >> 8) & 1) == ((byte)(uVar41 >> 9) & 1))) << 1 |
          (uint)(((byte)(uVar12 >> 8) & 1) == ((byte)(uVar12 >> 9) & 1));
  uVar13 = uVar11 * 2 | (uint)((uVar13 & 4) != 0);
  bVar3 = ((byte)(uVar10 >> 8) & 1) == ((byte)(uVar10 >> 9) & 1);
  bVar2 = (bool)((byte)(uVar10 >> 9) & 1) == ((uVar11 & 0x80000000) != 0);
  uVar10 = (uint)bVar3 * (uVar13 - in_r0) + (uint)!bVar3 * (uVar13 + in_r0);
  cVar1 = bVar3 * (uVar13 < uVar10) + !bVar3 * (uVar10 < uVar13);
  uVar9 = uVar6 | uVar9 & 0xfffffeff | (uint)(byte)(bVar2 * cVar1 + (!bVar2 && cVar1 == '\0')) << 8;
  if (((byte)(uVar9 >> 8) & 1) == ((byte)(uVar9 >> 9) & 1)) {
    return CONCAT44(uVar8,uVar10);
  }
  return CONCAT44(uVar8,in_r0 + uVar10);
}


undefined4 mark_bad_blocks___(void)

{
  undefined *puVar1;
  int iVar2;
  int iVar3;
  byte *extraout_r3;
  uint uVar4;
  undefined4 unaff_r10;
  int *piVar5;
  byte abStack_20 [12];
  
  puVar1 = PTR_PTR_SetOnChipReg__060273b8;
  piVar5 = (int *)(PTR_PTR_SetOnChipReg__060273b8 + 0x14);
  setupPowersOf2Struct(abStack_20);
  iVar3 = *(int *)(*piVar5 + 0x30) + *(int *)(*piVar5 + 0x40);
  for (uVar4 = 0; uVar4 < *(uint *)(*piVar5 + 0x38) >> 3; uVar4 = uVar4 + 1) {
    *(undefined *)(*(int *)(*piVar5 + 0x2c) + uVar4) = *(undefined *)(uVar4 * 2 + iVar3 + 1);
  }
  iVar2 = (*(code *)(PTR_LAB_060273bc + 0x6027348))();
  *extraout_r3 = *extraout_r3 | abStack_20[iVar2];
  if (*(int *)(*piVar5 + 0x34) == 1) {
    unaff_r10 = *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_060273c0;
    (**(code **)puVar1)(0xffffffff);
  }
  for (uVar4 = 0; uVar4 < *(uint *)(*piVar5 + 0x3c); uVar4 = uVar4 + 1) {
    if (uVar4 < *(uint *)(*piVar5 + 0x38) >> 3) {
      *(undefined *)(uVar4 * 2 + iVar3 + 1) = *(undefined *)(*(int *)(*piVar5 + 0x2c) + uVar4);
    }
    else {
      *(undefined *)(uVar4 * 2 + iVar3 + 1) = 0;
    }
  }
  if (*(int *)(*piVar5 + 0x34) == 1) {
    (*(code *)(PTR_DAT_060273c4 + 0x60273b2))();
  }
  uVar4 = 0;
  while( true ) {
    if (*(uint *)(*piVar5 + 0x38) >> 3 <= uVar4) {
      if (*(int *)(*piVar5 + 0x34) == 1) {
        (**(code **)puVar1)(unaff_r10);
      }
      return 0;
    }
    if (*(char *)(uVar4 * 2 + iVar3 + 1) != *(char *)(*(int *)(*piVar5 + 0x2c) + uVar4)) break;
    uVar4 = uVar4 + 1;
  }
  if (*(int *)(*piVar5 + 0x34) == 1) {
    (**(code **)puVar1)(unaff_r10);
  }
  return 8;
}


void BUP_GetDate(int minutes_since_1980,backup_date *date)

{
  undefined *days_since_1980;
  byte bVar1;
  uint days;
  char cVar2;
  undefined4 days_00;
  char cVar3;
  
                    /* Divide by 1440 (number of minutes in a day) */
  days_since_1980 =
       (undefined *)
       (*(code *)(PTR_LAB_060282e0 + 0x60282a4))(minutes_since_1980,date,(int)(short)MINS_IN_DAY);
                    /* Calculate remainder as well */
  (*(code *)(PTR_LAB_060282e4 + 0x60282b0))();
                    /* divide remainder (minutes in a the partial day) by 60 to get hours */
  bVar1 = (*(code *)(PTR_LAB_060282e8 + 0x60282b8))();
  date->time = bVar1;
                    /* Get remainder % 60 to calculate mins */
  bVar1 = (*(code *)(PTR_LAB_060282ec + 0x60282c2))();
  date->min = bVar1;
                    /* Get the day of the week by modulo */
                    /* Check if for year 2100 */
  if (year_2100_in_days_since_1980 < days_since_1980) {
    bVar1 = (*(code *)(PTR_LAB_060282f4 + 0x60282d8))();
  }
  else {
    bVar1 = (*(code *)(PTR_LAB_06028370 + 0x6028302))(7);
  }
  date->week = bVar1;
  days = (*(code *)(PTR_LAB_06028374 + 0x602830e))();
                    /* Leap year calculation.  */
  if ((uint)(int)DAYS_366 < days) {
    cVar2 = (*(code *)(PTR_DAT_06028378 + 0x6028324))(days,(int)PTR_DAT_0602836c._0_2_,days - 1);
    days_00 = (*(code *)(PTR_LAB_0602837c + 0x602832e))();
    convert_days_to_month_date(days_00,&date->month,&date->day,0);
  }
  else {
    cVar2 = '\0';
    convert_days_to_month_date(days,&date->month,&date->day,0x1);
  }
  cVar3 = (*(code *)(PTR_DAT_06028380 + 0x6028356))();
  date->year = cVar3 * 0x4 + cVar2;
  return;
}


int crazyDiv2(int divisor,int dividend)

{
  bool bVar1;
  bool bVar2;
  uint uVar3;
  char cVar4;
  bool bVar5;
  bool bVar6;
  uint uVar7;
  uint uVar8;
  uint uVar9;
  uint uVar11;
  uint uVar12;
  uint uVar14;
  uint uVar15;
  uint uVar16;
  uint uVar17;
  uint uVar18;
  uint uVar19;
  uint uVar20;
  uint uVar21;
  uint uVar22;
  uint uVar23;
  uint uVar24;
  uint uVar25;
  uint uVar26;
  uint uVar27;
  uint uVar28;
  uint uVar29;
  uint uVar30;
  uint uVar31;
  uint uVar32;
  uint uVar33;
  uint uVar34;
  uint uVar35;
  uint uVar36;
  uint uVar37;
  uint uVar38;
  uint uVar39;
  uint uVar40;
  uint uVar41;
  uint uVar42;
  uint uVar10;
  uint uVar13;
  
  if (divisor != 0) {
    uVar8 = (uint)((dividend & 0x80000000U) != 0);
    uVar13 = -uVar8;
    uVar7 = dividend - (uint)(uVar13 != 0);
    bVar1 = (uVar13 & 0x80000000) != 0;
    bVar2 = (divisor & 0x80000000U) != 0;
    uVar3 = (uint)bVar2 << 9;
    uVar12 = uVar7 * 2;
    uVar8 = uVar8 * -2 | (uint)((uVar7 & 0x80000000) != 0);
    bVar5 = bVar1 == bVar2;
    bVar6 = bVar2 == ((uVar13 & 0x80000000) != 0);
    uVar7 = (uint)bVar5 * (uVar8 - divisor) + (uint)!bVar5 * (uVar8 + divisor);
    cVar4 = bVar5 * (uVar8 < uVar7) + !bVar5 * (uVar7 < uVar8);
    uVar8 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar13 = uVar3 | uVar8;
    uVar9 = uVar7 * 2 | (uint)((uVar12 & 0x80000000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar7 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar9 - divisor) + (uint)!bVar5 * (uVar9 + divisor);
    cVar4 = bVar5 * (uVar9 < uVar10) + !bVar5 * (uVar10 < uVar9);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar14 = uVar3 | uVar8 & 0xfffffeff | uVar13;
    uVar9 = uVar3 | uVar8 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x40000000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar15 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x20000000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar16 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x10000000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar17 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x8000000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar18 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x4000000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar19 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x2000000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar20 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x1000000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar21 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x800000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar22 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x400000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar23 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x200000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar24 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x100000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar25 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x80000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar26 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x40000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar27 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x20000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar28 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x10000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar29 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x8000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar30 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x4000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar31 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x2000) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar32 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x1000) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar33 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x800) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar34 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x400) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar35 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x200) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar36 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x100) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar37 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x80) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar38 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x40) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar39 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x20) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar40 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 0x10) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar41 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 8) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar13 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar42 = uVar9 | uVar7 & 0xfffffeff | uVar13;
    uVar9 = uVar9 | uVar7 & 0xfffffefe;
    uVar7 = uVar9 | uVar13;
    uVar11 = uVar10 * 2 | (uint)((uVar12 & 4) != 0);
    bVar5 = ((byte)(uVar7 >> 8) & 1) == ((byte)(uVar7 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar7 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar10 = (uint)bVar5 * (uVar11 - divisor) + (uint)!bVar5 * (uVar11 + divisor);
    cVar4 = bVar5 * (uVar11 < uVar10) + !bVar5 * (uVar10 < uVar11);
    uVar7 = (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    uVar11 = uVar9 | uVar13 & 0xfffffeff | uVar7;
    uVar9 = uVar9 | uVar13 & 0xfffffefe;
    uVar13 = uVar9 | uVar7;
    uVar12 = uVar10 * 2 | (uint)((uVar12 & 2) != 0);
    bVar5 = ((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1);
    bVar6 = (bool)((byte)(uVar13 >> 9) & 1) == ((uVar10 & 0x80000000) != 0);
    uVar13 = (uint)bVar5 * (uVar12 - divisor) + (uint)!bVar5 * (uVar12 + divisor);
    cVar4 = bVar5 * (uVar12 < uVar13) + !bVar5 * (uVar13 < uVar12);
    uVar13 = uVar9 | uVar7 & 0xfffffeff |
             (uint)(byte)(bVar6 * cVar4 + (!bVar6 && cVar4 == '\0')) << 8;
    return ((((((((((((((((((((((((((((((((uint)(((byte)((uVar3 | uVar8) >> 8) & 1) ==
                                                ((byte)((uVar3 | uVar8) >> 9) & 1)) << 1 |
                                         (uint)(((byte)(uVar14 >> 8) & 1) ==
                                               ((byte)(uVar14 >> 9) & 1))) << 1 |
                                        (uint)(((byte)(uVar15 >> 8) & 1) ==
                                              ((byte)(uVar15 >> 9) & 1))) << 1 |
                                       (uint)(((byte)(uVar16 >> 8) & 1) == ((byte)(uVar16 >> 9) & 1)
                                             )) << 1 |
                                      (uint)(((byte)(uVar17 >> 8) & 1) == ((byte)(uVar17 >> 9) & 1))
                                      ) << 1 | (uint)(((byte)(uVar18 >> 8) & 1) ==
                                                     ((byte)(uVar18 >> 9) & 1))) << 1 |
                                    (uint)(((byte)(uVar19 >> 8) & 1) == ((byte)(uVar19 >> 9) & 1)))
                                    << 1 | (uint)(((byte)(uVar20 >> 8) & 1) ==
                                                 ((byte)(uVar20 >> 9) & 1))) << 1 |
                                  (uint)(((byte)(uVar21 >> 8) & 1) == ((byte)(uVar21 >> 9) & 1))) <<
                                  1 | (uint)(((byte)(uVar22 >> 8) & 1) == ((byte)(uVar22 >> 9) & 1))
                                 ) << 1 | (uint)(((byte)(uVar23 >> 8) & 1) ==
                                                ((byte)(uVar23 >> 9) & 1))) << 1 |
                               (uint)(((byte)(uVar24 >> 8) & 1) == ((byte)(uVar24 >> 9) & 1))) << 1
                              | (uint)(((byte)(uVar25 >> 8) & 1) == ((byte)(uVar25 >> 9) & 1))) << 1
                             | (uint)(((byte)(uVar26 >> 8) & 1) == ((byte)(uVar26 >> 9) & 1))) << 1
                            | (uint)(((byte)(uVar27 >> 8) & 1) == ((byte)(uVar27 >> 9) & 1))) << 1 |
                           (uint)(((byte)(uVar28 >> 8) & 1) == ((byte)(uVar28 >> 9) & 1))) << 1 |
                          (uint)(((byte)(uVar29 >> 8) & 1) == ((byte)(uVar29 >> 9) & 1))) << 1 |
                         (uint)(((byte)(uVar30 >> 8) & 1) == ((byte)(uVar30 >> 9) & 1))) << 1 |
                        (uint)(((byte)(uVar31 >> 8) & 1) == ((byte)(uVar31 >> 9) & 1))) << 1 |
                       (uint)(((byte)(uVar32 >> 8) & 1) == ((byte)(uVar32 >> 9) & 1))) << 1 |
                      (uint)(((byte)(uVar33 >> 8) & 1) == ((byte)(uVar33 >> 9) & 1))) << 1 |
                     (uint)(((byte)(uVar34 >> 8) & 1) == ((byte)(uVar34 >> 9) & 1))) << 1 |
                    (uint)(((byte)(uVar35 >> 8) & 1) == ((byte)(uVar35 >> 9) & 1))) << 1 |
                   (uint)(((byte)(uVar36 >> 8) & 1) == ((byte)(uVar36 >> 9) & 1))) << 1 |
                  (uint)(((byte)(uVar37 >> 8) & 1) == ((byte)(uVar37 >> 9) & 1))) << 1 |
                 (uint)(((byte)(uVar38 >> 8) & 1) == ((byte)(uVar38 >> 9) & 1))) << 1 |
                (uint)(((byte)(uVar39 >> 8) & 1) == ((byte)(uVar39 >> 9) & 1))) << 1 |
               (uint)(((byte)(uVar40 >> 8) & 1) == ((byte)(uVar40 >> 9) & 1))) << 1 |
              (uint)(((byte)(uVar41 >> 8) & 1) == ((byte)(uVar41 >> 9) & 1))) << 1 |
             (uint)(((byte)(uVar42 >> 8) & 1) == ((byte)(uVar42 >> 9) & 1))) << 1 |
            (uint)(((byte)(uVar11 >> 8) & 1) == ((byte)(uVar11 >> 9) & 1))) << 1 |
           (uint)(((byte)(uVar13 >> 8) & 1) == ((byte)(uVar13 >> 9) & 1))) + (uint)(bVar2 != bVar1);
  }
  *(undefined4 *)PTR_DAT_06029a28 = DAT_06029a2c;
  return 0;
}


void SetOnChipReg_(undefined4 param_1)

{
  undefined *puVar1;
  
  puVar1 = PTR_SCU_IMS_060007e8;
  *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_060007ec = param_1;
  *(undefined4 *)puVar1 = param_1;
  *(int *)(puVar1 + 4) = (int)(short)param_1;
  if (-1 < (short)param_1) {
    *(undefined4 *)(puVar1 + 8) = 1;
  }
  return;
}


void setup_days_by_month(dword *months)

{
  *months = 31;
  months[1] = 59;
  months[2] = 90;
  months[3] = 120;
  months[4] = 151;
  months[5] = 181;
  months[6] = 212;
  months[7] = 243;
  months[8] = 273;
  months[9] = 304;
  months[10] = 334;
  return;
}


uint serial_write(int param_1,int param_2)

{
  undefined *puVar1;
  uint uVar2;
  int iVar3;
  undefined *puVar4;
  char *pcVar5;
  char *pcVar6;
  char *pcVar7;
  uint uVar8;
  uint uVar9;
  uint uVar10;
  uint uVar11;
  byte local_58 [4];
  uint uStack_54;
  int iStack_50;
  undefined local_4c;
  char local_4b [37];
  undefined auStack_26 [10];
  
  puVar1 = PTR_INTERNAL_METADATA_0602972c;
  uVar9 = (uint)DAT_06029726;
  iStack_50 = param_2;
  uVar2 = serial_send_cmd__(0x50,0,local_58);
  if (uVar2 == 0) {
    if (((int)(char)local_58[0] & 0xffU) == uVar9) {
      uVar2 = (uint)PTR_DAT_06029728._0_2_;
    }
    else {
      local_4c = 0x40;
      puVar4 = &local_4c;
      while (puVar4 = puVar4 + 1, puVar4 < auStack_26) {
        *puVar4 = 0;
      }
      for (uVar2 = 0; uVar2 < 0xb; uVar2 = uVar2 + 1) {
        local_4b[uVar2 + 3] = *(char *)(param_1 + uVar2);
      }
      for (uVar2 = 0; uVar2 < 10; uVar2 = uVar2 + 2) {
        local_4b[uVar2 + 0xf] = *(char *)(param_1 + 0xc + uVar2);
        local_4b[uVar2 + 0x10] = *(char *)(param_1 + uVar2 + 0xd);
      }
      local_4b[25] = *(undefined *)(param_1 + 0x17);
      pcVar5 = (char *)(param_1 + 0x18);
      pcVar7 = local_4b + 0x1f;
      for (pcVar6 = local_4b + 0x1b; pcVar6 < pcVar7; pcVar6 = pcVar6 + 2) {
        *pcVar6 = *pcVar5;
        pcVar6[1] = pcVar5[1];
        pcVar5 = pcVar5 + 2;
      }
      pcVar5 = (char *)(param_1 + 0x1c);
      for (; pcVar7 < local_4b + 0x23; pcVar7 = pcVar7 + 2) {
        *pcVar7 = *pcVar5;
        pcVar7[1] = pcVar5[1];
        pcVar5 = pcVar5 + 2;
      }
      uVar2 = (*(code *)(DAT_060297f8 + 0x60297cc))(&local_4c,0x26);
      if ((uVar2 == 0) &&
         (uVar2 = (*(code *)(DAT_06029800 + 0x60297e0))(&local_4c,6,PTR_DAT_060297fc), uVar2 == 0))
      {
        if (local_4b[2] == '\0') {
          uVar2 = *(uint *)(param_1 + 0x1c);
          iVar3 = (*(code *)(DAT_06029894 + 0x6029812))();
          uStack_54 = iVar3 + 1;
          uVar8 = 0;
          uVar11 = 0;
          if (uStack_54 != 0) {
            do {
              if (*(uint *)(*(int *)puVar1 + 0x68) < uVar2) {
                uVar10 = uVar2 - *(uint *)(*(int *)puVar1 + 0x68);
                uVar2 = *(uint *)(*(int *)puVar1 + 0x68);
              }
              else {
                uVar8 = uVar9 & 0xff;
                uVar10 = uVar2;
              }
              uVar2 = serial_write2(*(int *)(*(int *)puVar1 + 0x68) * uVar11 + iStack_50,uVar2,uVar8
                                   );
              if (uVar2 != 0) {
                return uVar2;
              }
              uVar2 = Serial_Read_error__(local_58);
              if (uVar2 != 0) {
                return uVar2;
              }
              uVar11 = uVar11 + 1;
              uVar2 = uVar10;
            } while (uVar11 < uStack_54);
          }
          if (((int)(char)local_58[0] & 0xffU) == uVar9) {
            uVar2 = 0;
          }
          else {
            uVar2 = (uint)PTR_DAT_06029890._0_2_;
          }
        }
        else {
          uVar2 = (int)local_4b[2] & 0xff;
        }
      }
    }
  }
  return uVar2;
}


uint serial_readfile(char *filename,byte *out,char param_3)

{
  uint uVar1;
  char *pcVar2;
  char *pcVar3;
  int iVar4;
  uint uVar5;
  byte local_54 [4];
  char acStack_50 [4];
  int iStack_4c;
  char cStack_48;
  byte *pbStack_44;
  char *pcStack_40;
  byte local_3c;
  char local_3b [37];
  char acStack_16 [6];
  
  uVar5 = (uint)DAT_0602947a;
  cStack_48 = param_3;
  pbStack_44 = out;
  pcStack_40 = filename;
  uVar1 = serial_send_cmd__(0x41,0,local_54);
  if (((int)(char)local_54[0] & 0xffU) == uVar5) {
    uVar1 = (uint)PTR_DAT_0602947c._0_2_;
  }
  else if (uVar1 == 0) {
    local_3c = 0x40;
    pcVar2 = local_3b;
    do {
      *pcVar2 = '\0';
      pcVar2 = pcVar2 + 1;
    } while (pcVar2 < acStack_16);
    pcVar3 = local_3b + 3;
    pcVar2 = pcStack_40;
    do {
      *pcVar3 = *pcVar2;
      pcVar3 = pcVar3 + 1;
      pcVar2 = pcVar2 + 1;
    } while (pcVar3 < local_3b + 0xe);
    uVar1 = serial_send_data2__(&local_3c,0x26);
    if ((uVar1 == 0) && (uVar1 = serial_read_data___(&local_3c,6,PTR_DAT_06029480), uVar1 == 0)) {
      if (local_3b[2] == '\0') {
        acStack_50[0] = '\0';
        iVar4 = 0;
        do {
          if ((((int)acStack_50[0] & 0xffU) == uVar5) || (((int)(char)local_54[0] & 0xffU) == uVar5)
             ) {
            if (((int)(char)local_54[0] & 0xffU) == uVar5) {
              return 0;
            }
            return (int)DAT_060294fc;
          }
          uVar1 = serial_read_file2(pbStack_44 + iVar4,&iStack_4c,acStack_50,(int)cStack_48);
          if (uVar1 != 0) {
            return uVar1;
          }
          iVar4 = iVar4 + iStack_4c;
          uVar1 = serial_send_cmd__(0,0,local_54);
        } while (uVar1 == 0);
      }
      else {
        uVar1 = (int)local_3b[2] & 0xff;
      }
    }
  }
  return uVar1;
}


BUP_ERROR BUP_Verify(BACKUP_DEVICE device,uchar *filename,uchar *data)

{
  int iVar1;
  BUP_ERROR BVar2;
  short block_id;
  backup_stat stat;
  
  if (device != DEVICE_SERIAL) {
                    /* jo_backup_driver_stat
                        */
    BVar2 = (*(code *)(DAT_06027fd0 + 0x6027f90))(device,0,&stat);
    if (BVar2 != BUP_SUCCESS) {
      return BVar2;
    }
    block_id = SearchForSaveBlock((char *)filename,DEFAULT);
    if (block_id != 0) {
      BVar2 = ChecksumData(block_id,data);
      return BVar2;
    }
    return BUP_NOT_FOUND;
  }
  if ((*PTR_INTERNAL_METADATA_06027f58)->serial_connected == 0) {
    return BUP_NOT_CONNECTED;
  }
  iVar1 = (*(code *)(PTR_DAT_06027f5c + 0x6027f1a))(filename,data,1);
  if (iVar1 == 0) {
    return BUP_SUCCESS;
  }
  if (iVar1 == 0x21) {
    return BUP_NOT_CONNECTED;
  }
  if (iVar1 == 0x23) {
    return BUP_WRITE_PROTECTED;
  }
  if (iVar1 == 0x24) {
    return BUP_NOT_FORMATTED;
  }
  if ((iVar1 != DAT_06027fc8) && (iVar1 != DAT_06027fca)) {
    if (iVar1 != PTR_DAT_06027fcc._0_2_) {
      return ~BUP_SUCCESS;
    }
    return BUP_NO_MATCH;
  }
  return BUP_NOT_CONNECTED;
}


int CheckForSerial(backup_config *config)

{
  int result;
  undefined *puVar1;
  SERIAL_STRUCT serial_struct;
  
                    /* Do something SCR??
                        */
  puVar1 = (undefined *)(int)DAT_06028570;
  *puVar1 = 0;
  puVar1[-2] = (char)DAT_06028572;
  puVar1[-1] = 0x10;
  (*PTR_INTERNAL_METADATA_06028578)->serial_partition_number = 0;
  result = Serial_SetPartition(&serial_struct,0);
  if ((result != PTR_DAT_06028574._0_2_) && (result != 0)) {
    result = Serial_SetPartition(&serial_struct,0);
  }
  if (result != 0) {
    return result;
  }
  (*PTR_INTERNAL_METADATA_06028578)->something_serial_ = (int)serial_struct.saved_to_im & 0xffff;
  config->unit_id = (short)(char)serial_struct.unit_id & 0xff;
  config->partition = (short)(char)serial_struct.partition_id & 0xff;
  return 0;
}


int CountReservedBlocks(void)

{
  uint i;
  int reserved_blocks;
  byte powers_of_two [12];
  INTERNAL_METADATA **im;
  
  im = PTR_INTERNAL_METADATA_06028170;
  (*(code *)(DAT_06028174 + 0x6028166))(powers_of_two);
  reserved_blocks = 0;
  for (i = (*im)->offset_of_filedata_in_blocks; i < (*im)->totalBlocks; i = i + 1) {
    if ((*(byte *)((i >> 3) * 2 + (*im)->backup_ram_bad_blocks_bitmap + 1) & powers_of_two[i & 7])
        != 0) {
      reserved_blocks = reserved_blocks + 1;
    }
  }
  return reserved_blocks;
}


/* Find filename in the backup memory. Returns the block index on success or 0 on failure. Search
   mode is None, Save, and Resume.  */

uint SearchForSaveBlock(char *filename,SEARCH_MODE search_mode)

{
  INTERNAL_METADATA *im;
  uint j;
  uint currBlockIndex;
  byte *backup_ram;
  byte powers_of_two [16];
  INTERNAL_METADATA **pim;
  
  pim = PTR_INTERNAL_METADATA_060278c8;
  (*(code *)(DAT_060278cc + 0x6027876))(powers_of_two);
  if (search_mode == RESUME_SEARCH) {
    (*pim)->last_found_block_search = (*pim)->last_found_block_search + 1;
  }
  else {
    (*pim)->last_found_block_search = (*pim)->offset_of_filedata_in_blocks;
  }
  im = *pim;
  currBlockIndex = im->last_found_block_search;
                    /* Loop through all blocks */
  backup_ram = im->backup_ram_start + im->last_found_block_search * im->blockSize_in_bytes;
  do {
    if ((*pim)->totalBlocks <= currBlockIndex) {
      return 0;
    }
                    /* Look at all SAT_START_BLOCKs. These start with 0x80000000 and contain the
                       SAT_START_BLOCK_HEADER structure. This structure contains the filename. We
                       need to read every other byte because only every other byte is mapped in.  */
    if (((char)backup_ram[1] < 0) &&
       ((*(byte *)((currBlockIndex >> 3) * 2 +
                   (*PTR_INTERNAL_METADATA_06027998)->backup_ram_bad_blocks_bitmap + 1) &
        powers_of_two[currBlockIndex & 7]) == 0)) {
      j = 0;
      do {
        if (backup_ram[j * 2 + 9] == filename[j]) {
          if ((j == 0xb) || (filename[j] == '\0')) {
            (*pim)->last_found_block_search = currBlockIndex;
            return currBlockIndex & 0xffff;
          }
        }
        else {
          if ((filename[j] == '\0') && (search_mode != DEFAULT)) {
            (*pim)->last_found_block_search = currBlockIndex;
            return currBlockIndex & 0xffff;
          }
          if (j == 0xb) {
            (*pim)->last_found_block_search = currBlockIndex;
            return currBlockIndex & 0xffff;
          }
          j = 0xc;
        }
        j = j + 1;
      } while (j < 0xc);
    }
    backup_ram = backup_ram + (*pim)->blockSize_in_bytes;
    currBlockIndex = currBlockIndex + 1;
  } while( true );
}


/* Convert jo_backup_date to minutes_since_1980 */

uint BUP_SetDate(backup_date *date)

{
  int years;
  int days;
  uint month;
  dword month_days [13];
  
  setup_days_by_month(month_days);
                    /* Divide year by 4? */
  days = (*(code *)(PTR_LAB_06028428 + 0x60283a0))();
  days = days * (short)DAYS_IN_4_YEARS;
  years = (*(code *)(PTR_DAT_0602842c + 0x60283ae))();
  if (years != 0) {
    days = days + years * (short)DAYS_IN_YEAR + 1;
  }
  if ((((date->month != 1) && (date->month < 0xd)) &&
      (month = (int)(char)date->month & 0xff, days = days + month_days[month - 2], 2 < month)) &&
     (years == 0)) {
    days = days + 1;
  }
  return (days + (((int)(char)date->day & 0xffU) - 1)) * (int)(short)MINUTES_IN_DAY +
         ((int)(char)date->time & 0xffU) * 0x3c + ((int)(char)date->min & 0xffU);
}


BUP_ERROR BUP_Format(BACKUP_DEVICE device)

{
  byte *pbVar3;
  BUP_ERROR BVar1;
  byte *block;
  byte *pbVar2;
  byte *ram_addr;
  uint i;
  uint j;
  int k;
  dword block_sector___;
  byte *backup_ram_start;
  code *waitLoopFP;
  INTERNAL_METADATA **im;
  undefined4 onChipFlags__;
  byte backup_ram_str [20];
  byte powers_of_two [8];
  backup_stat device_stat;
  undefined *setOnChipFP;
  
  setOnChipFP = PTR_PTR_SetOnChipReg__06026830;
  waitLoopFP = (code *)(PTR_DAT_0602682c + 0x60267e4);
  im = (INTERNAL_METADATA **)(PTR_PTR_SetOnChipReg__06026830 + 0x14);
  if (device == DEVICE_SERIAL) {
    if ((*im)->serial_connected == 0) {
      BVar1 = BUP_NOT_CONNECTED;
    }
    else {
      k = (*(code *)(PTR_LAB_06026834 + 0x6026818))((int)(char)(*im)->serial_partition_number);
      if (k == 0) {
        BVar1 = BUP_SUCCESS;
      }
      else if (k == 0x21) {
        BVar1 = BUP_NOT_CONNECTED;
      }
      else if (k == 0x23) {
        BVar1 = BUP_WRITE_PROTECTED;
      }
      else {
        BVar1 = ~BUP_SUCCESS;
      }
    }
  }
  else {
    setupPowersOf2Struct(powers_of_two);
    InitBackupRamFormatString((char *)backup_ram_str);
    BVar1 = BUP_Stat(device,0,&device_stat);
    if ((BVar1 == BUP_SUCCESS) || (BVar1 == BUP_NOT_FORMATTED)) {
      for (i = 0; i < (*im)->totalBlocks; i = i + 1) {
        *(undefined *)((int)(*im)->sat_blocks + i) = 0;
                    /* TODO: what are we zeroing out here? Is fileID a pointer to BUP memory? Or is
                       it a  list of handles? */
      }
      if ((*im)->cart_format_flag_ == 1) {
        onChipFlags__ = *(undefined4 *)PTR_PTR_TO_0xFFFFF17C_060268dc;
        (**(code **)setOnChipFP)(0xffffffff);
        if ((*im)->blockSize == (int)BLOCK_SIZE_0x200) {
          *(byte *)((int)(*im)->sat_blocks + 5) = powers_of_two[2];
        }
        else if ((*im)->blockSize == (int)BLOCK_SIZE_0x100) {
          *(byte *)((*im)->sat_blocks + 5) = powers_of_two[5];
        }
      }
                    /* Write the string "BackupRam Format" at the beginning of backup ram. There are
                       blocksize >> 4 of these 16 byte strings to start memory.  */
      backup_ram_start = (*im)->backup_ram_start;
      for (i = 0; i < (*im)->blockSize >> 4; i = i + 1) {
        j = 0;
        do {
          k = j + 1;
          backup_ram_start[(i * 0x10 + j) * 2 + 1] = backup_ram_str[j];
          j = j + 2;
          backup_ram_start[(i * 0x10 + k) * 2 + 1] = backup_ram_str[k];
        } while (j < 0x10);
      }
      if ((*im)->cart_format_flag_ == 1) {
        (*waitLoopFP)();
      }
      for (i = 2; i < (*im)->totalBlocks; i = i + 1) {
        block_sector___ = (*im)->blockSize_in_bytes;
        block = (*im)->backup_ram_start;
        for (j = 0; j < (*im)->blockSize; j = j + 1) {
          block[j * 2 + block_sector___ * i + 1] = 0;
        }
        if ((*im)->cart_format_flag_ == 1) {
          (*waitLoopFP)();
        }
      }
      for (i = 2; i < (*im)->totalBlocks; i = i + 1) {
        pbVar2 = (*im)->backup_ram_start;
        block_sector___ = (*im)->blockSize_in_bytes;
        for (j = 0; j < (*im)->blockSize; j = j + 1) {
          if (pbVar2[j * 2 + block_sector___ * i + 1] != 0) {
            pbVar3 = (byte *)((int)(*im)->sat_blocks + (i >> 3));
            *pbVar3 = *pbVar3 | powers_of_two[i & 7];
          }
        }
      }
      pbVar2 = (*im)->backup_ram_start;
      block_sector___ = (*im)->blockSize_in_bytes;
      for (i = 0; i < (*im)->blockSize; i = i + 1) {
        if (i < (*im)->totalBlocks >> 3) {
          pbVar2[i * 2 + block_sector___ + 1] = *(byte *)((int)(*im)->sat_blocks + i);
        }
        else {
          pbVar2[i * 2 + block_sector___ + 1] = 0;
        }
      }
      if ((*im)->cart_format_flag_ == 1) {
        (*waitLoopFP)();
      }
      for (i = 0; i < (*im)->totalBlocks >> 3; i = i + 1) {
        if (pbVar2[i * 2 + block_sector___ + 1] != *(byte *)((int)(*im)->sat_blocks + i)) {
          if ((*im)->cart_format_flag_ == 1) {
            (**(code **)setOnChipFP)(onChipFlags__);
          }
          return BUP_BROKEN;
        }
      }
      if ((*im)->cart_format_flag_ == 1) {
        (**(code **)setOnChipFP)(onChipFlags__);
      }
      BVar1 = BUP_SUCCESS;
    }
  }
  return BVar1;
}


